// ComCertArray.cpp : Implementation of CComCertArray
#include "stdafx.h"
#include "DigiDocLibCOM_h.h"
#include "ComCertArray.h"
#include "ComCertificate.h"
#include "Converters.h"
#include "ComCertSearchStore.h"


/////////////////////////////////////////////////////////////////////////////
// CComCertArray


//////////////////////////////////////////////////////////////
//        properties
//////////////////////////////////////////////////////////////
STDMETHODIMP CComCertArray::get_nCerts(long *pVal)
{
	*pVal = m_nCertCount;

	return S_OK;
}


//////////////////////////////////////////////////////////////
//        methods
//////////////////////////////////////////////////////////////
STDMETHODIMP CComCertArray::getCertByIndex(long nIndex, IComCertificate *pStoreTo)
{
	((CComCertificate*)pStoreTo)->shiftStructPointer(m_pX509Array[nIndex]);

	return S_OK;
}

STDMETHODIMP CComCertArray::clear()
{
	freeStruct_soft();

	return S_OK;
}

STDMETHODIMP CComCertArray::searchBySearchStore(IComCertSearchStore *pSearchStore, long *nRetCode)
{

  freeStruct_soft();
  *nRetCode = ::findAllCertificates(
      ((CComCertSearchStore*)pSearchStore)->getCertSearchStore(),
      &m_pX509Array, &m_nCertCount);

	return S_OK;
}

////////////////////////////////////////////////////////////////////
//    helpers
////////////////////////////////////////////////////////////////////
CComCertArray::CComCertArray() {
  m_pX509Array = (X509**)0;
  m_nCertCount = 0;
}


CComCertArray::~CComCertArray() {
	freeStruct_soft();
}


void CComCertArray::freeStruct_soft() {
	if (m_pX509Array)
    freeStruct_hard();
}


void CComCertArray::freeStruct_hard() {
	for (int i = 0; i < m_nCertCount; i++)
    ::X509_free(m_pX509Array[i]);
  m_nCertCount = 0;
}



X509 * CComCertArray::getArray(void)
{
if (m_pX509Array != NULL)
  return(m_pX509Array[0]);
else
  return NULL;
}
