/*

Handles X509 certificates if findAllCertificates
returns more than one cert.
Copyright (C) AS Sertifitseerimiskeskus

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

GNU Lesser General Public Licence is available at
http://www.gnu.org/copyleft/lesser.html

*/
// ComCertArray.h : Declaration of the CComCertArray

#ifndef __COMCERTARRAY_H_
#define __COMCERTARRAY_H_

#include "resource.h"       // main symbols

//#include "DigiDocCsp.h"
/////////////////////////////////////////////////////////////////////////////
// CComCertArray
class ATL_NO_VTABLE CComCertArray : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CComCertArray, &CLSID_ComCertArray>,
	public IDispatchImpl<IComCertArray, &IID_IComCertArray, &LIBID_DIGIDOCLIBCOMLib>
{
public:
	CComCertArray();
  ~CComCertArray();

DECLARE_REGISTRY_RESOURCEID(IDR_COMCERTARRAY)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CComCertArray)
	COM_INTERFACE_ENTRY(IComCertArray)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()

// IComCertArray
public:
	STDMETHOD(searchBySearchStore)(/*[in]*/ IComCertSearchStore* pSearchStore, /*[out, retval]*/ long* nRetCode);
	STDMETHOD(clear)();
	STDMETHOD(getCertByIndex)(/*[in]*/ long nIndex, /*[in]*/ IComCertificate* pStoreTo);
	STDMETHOD(get_nCerts)(/*[out, retval]*/ long *pVal);


  void freeStruct_soft();
  void freeStruct_hard();


protected:
  X509** m_pX509Array;
  int m_nCertCount;
public:
	X509 * getArray(void);
};

#endif //__COMCERTARRAY_H_
