// ComCertSearchStore.cpp : Implementation of CComCertSearchStore
#include "stdafx.h"
#include "DigiDocLibCOM_h.h"
#include "ComCertSearchStore.h"

/////////////////////////////////////////////////////////////////////////////
// CComCertSearchStore


//////////////////////////////////////////////////////////////
//        properties
//////////////////////////////////////////////////////////////

STDMETHODIMP CComCertSearchStore::get_szStoreName(BSTR *pVal)
{
  Convert::copysz2BSTR_withAlloc(m_pCertSearchStore->storeName, pVal);

	return S_OK;
}

STDMETHODIMP CComCertSearchStore::put_szStoreName(BSTR newVal)
{
  Convert::in_BSTR2sz(newVal, &(m_pCertSearchStore->storeName));

	return S_OK;
}

STDMETHODIMP CComCertSearchStore::get_nCertSerial(long *pVal)
{
	
	*pVal = m_pCertSearchStore->certSerial;

	return S_OK;
}

STDMETHODIMP CComCertSearchStore::put_nCertSerial(long newVal)
{
	m_pCertSearchStore->certSerial = newVal;

	return S_OK;
}

STDMETHODIMP CComCertSearchStore::get_saSubDNCriterias(VARIANT *pVal)
{
	Convert::out_szarr2VARIANT(m_pCertSearchStore->subDNCriterias, pVal, 
      m_pCertSearchStore->numberOfSubDNCriterias);

	return S_OK;
}

STDMETHODIMP CComCertSearchStore::put_saSubDNCriterias(VARIANT newVal)
{
	Convert::in_VARIANT2szarr(newVal, 
      m_pCertSearchStore->subDNCriterias, 
      &(m_pCertSearchStore->numberOfSubDNCriterias));

	return S_OK;
}

STDMETHODIMP CComCertSearchStore::get_saIssuerDNCriterias(VARIANT *pVal)
{
	Convert::out_szarr2VARIANT(m_pCertSearchStore->issDNCriterias, pVal, 
      m_pCertSearchStore->numberOfIssDNCriterias);

	return S_OK;
}

STDMETHODIMP CComCertSearchStore::put_saIssuerDNCriterias(VARIANT newVal)
{
	Convert::in_VARIANT2szarr(newVal, 
      m_pCertSearchStore->issDNCriterias, 
      &(m_pCertSearchStore->numberOfIssDNCriterias));

	return S_OK;
}

STDMETHODIMP CComCertSearchStore::get_nSubDNCriterias(long *pVal)
{
	*pVal = m_pCertSearchStore->numberOfSubDNCriterias;

	return S_OK;
}

STDMETHODIMP CComCertSearchStore::get_nIssuerDNCriterias(long *pVal)
{
	*pVal = m_pCertSearchStore->numberOfIssDNCriterias;

	return S_OK;
}



//////////////////////////////////////////////////////////////
//        methods
//////////////////////////////////////////////////////////////
STDMETHODIMP CComCertSearchStore::addSearchType(long nCertSearchStoreType)
{
	m_pCertSearchStore->searchType |= nCertSearchStoreType;

	return S_OK;
}

STDMETHODIMP CComCertSearchStore::removeSearchType(long nCertSearchStoreType)
{
	m_pCertSearchStore->searchType &= (~nCertSearchStoreType);

	return S_OK;
}



////////////////////////////////////////////////////////////////////
//    helpers
////////////////////////////////////////////////////////////////////
CComCertSearchStore::CComCertSearchStore() {
  m_pointerMode = false;
  m_pCertSearchStore = ::CertSearchStore_new();
}
CComCertSearchStore::~CComCertSearchStore() {
  if (!m_pointerMode)
    freeStruct();
}

CertSearchStore* CComCertSearchStore::getCertSearchStore() {
  return m_pCertSearchStore;
}

void CComCertSearchStore::shiftStructPointer(CertSearchStore* pNew) {
  if (!m_pointerMode)
    freeStruct();
  m_pCertSearchStore = pNew;
  m_pointerMode = true;
}

void CComCertSearchStore::freeStruct() {
  ::CertSearchStore_free(m_pCertSearchStore);
}
