/*

Wrap of DigiCoc library CertSearchStore structure to provide COM-interface
Copyright (C) AS Sertifitseerimiskeskus

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

GNU Lesser General Public Licence is available at
http://www.gnu.org/copyleft/lesser.html

*/
// ComCertSearchStore.h : Declaration of the CComCertSearchStore

#ifndef __COMCERTSEARCHSTORE_H_
#define __COMCERTSEARCHSTORE_H_

#include "resource.h"       // main symbols

#include "libdigidoc/DigiDocCsp.h"
#include "Converters.h"

/////////////////////////////////////////////////////////////////////////////
// CComCertSearchStore
class ATL_NO_VTABLE CComCertSearchStore : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CComCertSearchStore, &CLSID_ComCertSearchStore>,
	public IDispatchImpl<IComCertSearchStore, &IID_IComCertSearchStore, &LIBID_DIGIDOCLIBCOMLib>
{
public:
	CComCertSearchStore();
	~CComCertSearchStore();

DECLARE_REGISTRY_RESOURCEID(IDR_COMCERTSEARCHSTORE)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CComCertSearchStore)
	COM_INTERFACE_ENTRY(IComCertSearchStore)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()

// IComCertSearchStore
public:
	STDMETHOD(removeSearchType)(/*[in]*/ long nCertSearchStoreType);
	STDMETHOD(addSearchType)(/*[in]*/ long nCertSearchStoreType);
	STDMETHOD(get_nIssuerDNCriterias)(/*[out, retval]*/ long *pVal);
	STDMETHOD(get_nSubDNCriterias)(/*[out, retval]*/ long *pVal);
	STDMETHOD(get_saIssuerDNCriterias)(/*[out, retval]*/ VARIANT *pVal);
	STDMETHOD(put_saIssuerDNCriterias)(/*[in]*/ VARIANT newVal);
	STDMETHOD(get_saSubDNCriterias)(/*[out, retval]*/ VARIANT *pVal);
	STDMETHOD(put_saSubDNCriterias)(/*[in]*/ VARIANT newVal);
	STDMETHOD(get_nCertSerial)(/*[out, retval]*/ long *pVal);
	STDMETHOD(put_nCertSerial)(/*[in]*/ long newVal);
	STDMETHOD(get_szStoreName)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(put_szStoreName)(/*[in]*/ BSTR newVal);

  CertSearchStore* getCertSearchStore();
  void shiftStructPointer(CertSearchStore* pNew);
  void freeStruct();

protected:
  CertSearchStore* m_pCertSearchStore;
  bool m_pointerMode;
};

#endif //__COMCERTSEARCHSTORE_H_
