// ComCertificate.cpp : Implementation of CComCertificate
#include "stdafx.h"
#include "DigiDocLibCOM_h.h"
#include "ComCertificate.h"
#include "Converters.h"
#include "libdigidoc/DigiDocMem.h"
#include "libdigidoc/DigiDocCert.h"
#include "libdigidoc/DigiDocConvert.h"

/////////////////////////////////////////////////////////////////////////////
// CComCertificate


//////////////////////////////////////////////////////////////
//        properties
//////////////////////////////////////////////////////////////
STDMETHODIMP CComCertificate::get_hHandle(long *pVal)
{
	*pVal = (long)m_pX509;

	return S_OK;
}

STDMETHODIMP CComCertificate::get_containsCert(VARIANT *pVal)
{
  VariantInit(pVal);
	V_VT(pVal) = VT_BOOL;
	V_BOOL(pVal) = ((m_pX509 == NULL) ? FALSE : TRUE);
  
	return S_OK;
}

STDMETHODIMP CComCertificate::get_szPropSubjectName(BSTR *pVal)
{
  DigiDocMemBuf mbuf1, mbuf2;

  mbuf1.pMem = 0;
  mbuf1.nLen = 0;
  mbuf2.pMem = 0;
  mbuf2.nLen = 0;
  USES_CONVERSION;
  if (::ddocCertGetSubjectDN(m_pX509, &mbuf1) != 0) {
      SetBSTR(pVal,""); //*pVal = SysAllocString(A2OLE(""));
  } else {
	  ddocMemSetLength(&mbuf2, mbuf1.nLen + 10);
      utf82oem((const char*)mbuf1.pMem, (char*)mbuf2.pMem, mbuf2.nLen);
      SetBSTR(pVal, (char*)mbuf2.pMem); //*pVal = SysAllocStringLen(A2OLE(buf), bLen);
  }
  ddocMemBuf_free(&mbuf1);
  ddocMemBuf_free(&mbuf2);
  return S_OK;
}

STDMETHODIMP CComCertificate::get_szPropIssuerName(BSTR *pVal)
{
  DigiDocMemBuf mbuf1, mbuf2;

  mbuf1.pMem = 0;
  mbuf1.nLen = 0;
  mbuf2.pMem = 0;
  mbuf2.nLen = 0;
  USES_CONVERSION;
  if (::ddocCertGetIssuerDN((X509*)m_pX509, &mbuf1) != 0) {
     SetBSTR(pVal,""); //*pVal = SysAllocString(A2OLE(""));
  } else {
	 ddocMemSetLength(&mbuf2, mbuf1.nLen + 10);
     utf82oem((const char*)mbuf1.pMem, (char*)mbuf2.pMem, mbuf2.nLen);
     SetBSTR(pVal, (char*)mbuf2.pMem); //*pVal = SysAllocStringLen(A2OLE(buf), bLen);
  }
  ddocMemBuf_free(&mbuf1);
  ddocMemBuf_free(&mbuf2);
  return S_OK;
}

STDMETHODIMP CComCertificate::get_nPropSerialNumber(BSTR *pVal)
{
  char buf[X509_NAME_BUF_LEN];
	//AA-Viimase minuti jama
	::ReadCertSerialNumber(buf,sizeof(buf),m_pX509);
    USES_CONVERSION;
	*pVal = SysAllocString(A2OLE(buf));
	//*pVal = atol(buf);
	//if (::getCertSerialNumber((void*)m_pX509, (int*)pVal) != 0) {
    //*pVal = 0;
    //}

	return S_OK;
}


//////////////////////////////////////////////////////////////
//        methods
//////////////////////////////////////////////////////////////



////////////////////////////////////////////////////////////////////
//    helpers
////////////////////////////////////////////////////////////////////
CComCertificate::CComCertificate() {
  m_pointerMode = true;
  m_pX509 = (X509*)0;
}

CComCertificate::~CComCertificate() {
  freeStruct_soft();
}

X509* CComCertificate::getX509() {
  return m_pX509;
}

void CComCertificate::shiftStructPointer(X509* pNew) {
  freeStruct_soft();
  m_pX509 = pNew;
  m_pointerMode = true; // I don't own this cert
}

void CComCertificate::takeOwnershipOn(X509* pNew) {
  freeStruct_soft();
  m_pX509 = pNew;
	m_pointerMode = false; // now I have this cert
}

void CComCertificate::freeStruct_soft() {
  if (!m_pointerMode && m_pX509) {
    freeStruct_hard();
  }
	m_pX509 = (X509*)0;
}

void CComCertificate::freeStruct_hard() {
  ::X509_free(m_pX509); 
	m_pX509 = (X509*)0;
}



