/*

Wraps X509 certificate for using with ComCertArray class.
Copyright (C) AS Sertifitseerimiskeskus

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

GNU Lesser General Public Licence is available at
http://www.gnu.org/copyleft/lesser.html

*/
// ComCertificate.h : Declaration of the CComCertificate

#ifndef __COMCERTIFICATE_H_
#define __COMCERTIFICATE_H_

#include "resource.h"       // main symbols


/////////////////////////////////////////////////////////////////////////////
// CComCertificate
class ATL_NO_VTABLE CComCertificate : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CComCertificate, &CLSID_ComCertificate>,
	public IDispatchImpl<IComCertificate, &IID_IComCertificate, &LIBID_DIGIDOCLIBCOMLib>
{
public:
	CComCertificate();
	~CComCertificate();

DECLARE_REGISTRY_RESOURCEID(IDR_COMCERTIFICATE)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CComCertificate)
	COM_INTERFACE_ENTRY(IComCertificate)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()

// IComCertificate
public:
	STDMETHOD(get_nPropSerialNumber)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(get_szPropIssuerName)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(get_szPropSubjectName)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(get_containsCert)(/*[out, retval]*/ VARIANT *pVal);
	STDMETHOD(get_hHandle)(/*[out, retval]*/ long *pVal);

  
  X509* getX509();

  void shiftStructPointer(X509* pNew);
	void takeOwnershipOn(X509* pNew);

  void freeStruct_soft();
  void freeStruct_hard();


protected:
  X509* m_pX509;
  bool m_pointerMode;
};

#endif //__COMCERTIFICATE_H_
