/*

Wrap of DigiCoc library DataFile structure to provide COM-interface
Copyright (C) AS Sertifitseerimiskeskus

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

GNU Lesser General Public Licence is available at
http://www.gnu.org/copyleft/lesser.html

*/
// ComDataFile.h : Declaration of the CComDataFile

#ifndef __COMDATAFILE_H_
#define __COMDATAFILE_H_

#include "resource.h"       // main symbols

/////////////////////////////////////////////////////////////////////////////
// CComDataFile
#include "ComSignedDoc.h"

class ATL_NO_VTABLE CComDataFile : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CComDataFile, &CLSID_ComDataFile>,
	public IDispatchImpl<IComDataFile, &IID_IComDataFile, &LIBID_DIGIDOCLIBCOMLib>
{
public:
	CComDataFile();
	~CComDataFile();

DECLARE_REGISTRY_RESOURCEID(IDR_COMDATAFILE)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CComDataFile)
	COM_INTERFACE_ENTRY(IComDataFile)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()

// IComDataFile
public:
	STDMETHOD(getAttributeValue)(/*[in]*/ long nIndex, /*[out, retval]*/ BSTR* szRetValue);
	STDMETHOD(getAttributeName)(/*[in]*/ long nIndex, /*[out, retval]*/ BSTR* szRetName);
	STDMETHOD(addAttribute)(/*[in]*/ BSTR szAttrName, /*[in]*/ BSTR szAttrValue);
	STDMETHOD(get_szaAttValues)(/*[out, retval]*/ VARIANT *pVal);
	STDMETHOD(get_szaAttNames)(/*[out, retval]*/ VARIANT *pVal);
	STDMETHOD(get_nAttributes)(/*[out, retval]*/ long *pVal);
	STDMETHOD(get_nDigestLen)(/*[out, retval]*/ long *pVal);
	STDMETHOD(get_baDigest)(/*[out, retval]*/ VARIANT *pVal);
	STDMETHOD(get_szDigestType)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(get_nSize)(/*[out, retval]*/ long *pVal);
	STDMETHOD(get_szContentType)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(get_szMimeType)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(get_szFileName)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(get_szId)(/*[out, retval]*/ BSTR *pVal);


  void shiftStructPointer(DataFile* pNew);
  void setSignedDoc(SignedDoc* pSigDoc) { m_pSignedDoc = pSigDoc; }

protected:
  DataFile* m_pDataFile;
  SignedDoc* m_pSignedDoc;  // this object is not owned by this interface!  
};

#endif //__COMDATAFILE_H_
