// ComDocInfo.cpp : Implementation of CComDocInfo
#include "stdafx.h"
#include "DigiDocLibCOM_h.h"
#include "ComDocInfo.h"
#include "Converters.h"

/////////////////////////////////////////////////////////////////////////////
// CComDocInfo


//////////////////////////////////////////////////////////////
//        properties
//////////////////////////////////////////////////////////////

STDMETHODIMP CComDocInfo::get_szDocId(BSTR *pVal)
{
  USES_CONVERSION;
  if (getDocInfo()->szDocId == (char*)0) {
    SetBSTR(pVal, ""); //*pVal = SysAllocString(A2OLE(""));
  } else {
    SetBSTR(pVal, getDocInfo()->szDocId); //*pVal = SysAllocString(A2OLE(getDocInfo()->szDocId));
  }

	return S_OK;
}

STDMETHODIMP CComDocInfo::put_szDocId(BSTR newVal)
{
  unsigned int newLen = SysStringLen(newVal);
  
  if (getDocInfo()->szDocId != (char*)0)
    delete getDocInfo()->szDocId;
  
  if (newLen > 0) {
    USES_CONVERSION;
    getDocInfo()->szDocId = new char[newLen + 1];
    strcpy(getDocInfo()->szDocId, GetBSTR(newVal));
  }
	
  return S_OK;
}

STDMETHODIMP CComDocInfo::get_szDigestType(BSTR *pVal)
{
  USES_CONVERSION;
  if (getDocInfo()->szDigestType == (char*)0) {
    SetBSTR(pVal, ""); //*pVal = SysAllocString(A2OLE(""));
  } else {
    SetBSTR(pVal, getDocInfo()->szDigestType); //*pVal = SysAllocString(A2OLE(getDocInfo()->szDigestType));
  }

	return S_OK;
}

STDMETHODIMP CComDocInfo::put_szDigestType(BSTR newVal)
{
  unsigned int newLen = SysStringLen(newVal);
  
  if (getDocInfo()->szDigestType != (char*)0)
    delete getDocInfo()->szDigestType;
  
  if (newLen > 0) {
    USES_CONVERSION;
    getDocInfo()->szDigestType = new char[newLen + 1];
    strcpy(getDocInfo()->szDigestType, GetBSTR(newVal));
  }

	return S_OK;
}


STDMETHODIMP CComDocInfo::get_baDigest(VARIANT *pVal)
{
	if (getDocInfo()->szDigest == (byte*)0) {
    V_VT(pVal)= VT_EMPTY;
  } else {
    SAFEARRAY* pArr = SafeArrayCreateVector(VT_UI1, 0, getDocInfo()->nDigestLen);

    V_ARRAY(pVal) = pArr;
    V_VT(pVal) = (VT_ARRAY | VT_UI1);

    byte HUGEP* pData;
    SafeArrayAccessData(pArr, (void HUGEP**)&pData);

    memcpy(pData, getDocInfo()->szDigest, getDocInfo()->nDigestLen);
    SafeArrayUnaccessData(pArr);
  }

	return S_OK;
}

STDMETHODIMP CComDocInfo::put_baDigest(VARIANT newVal)
{
	if (getDocInfo()->szDigest != (byte*)0)
    delete getDocInfo()->szDigest;
  
  SAFEARRAY* pArr = V_ARRAY(&newVal);
  byte HUGEP* pData;

  getDocInfo()->nDigestLen = pArr->rgsabound->cElements;
  if (getDocInfo()->nDigestLen > 0) {
    SafeArrayAccessData(pArr, (void HUGEP**)&pData);
    getDocInfo()->szDigest = new unsigned char[getDocInfo()->nDigestLen];
    memcpy(getDocInfo()->szDigest, pData, getDocInfo()->nDigestLen);
    SafeArrayUnaccessData(pArr);
  }

	return S_OK;
}

STDMETHODIMP CComDocInfo::get_baMimeDigest(VARIANT *pVal)
{
	if (getDocInfo()->szMimeDigest == (byte*)0) {
    V_VT(pVal)= VT_EMPTY;
  } else {
    SAFEARRAY* pArr = SafeArrayCreateVector(VT_UI1, 0, getDocInfo()->nMimeDigestLen);

    V_ARRAY(pVal) = pArr;
    V_VT(pVal) = (VT_ARRAY | VT_UI1);

    byte HUGEP* pData;
    SafeArrayAccessData(pArr, (void HUGEP**)&pData);

    memcpy(pData, getDocInfo()->szMimeDigest, getDocInfo()->nMimeDigestLen);
    SafeArrayUnaccessData(pArr);
  }

	return S_OK;
}

STDMETHODIMP CComDocInfo::put_baMimeDigest(VARIANT newVal)
{
	if (getDocInfo()->szMimeDigest != (byte*)0)
    delete getDocInfo()->szMimeDigest;
  
  SAFEARRAY* pArr = V_ARRAY(&newVal);
  byte HUGEP* pData;

  getDocInfo()->nMimeDigestLen = pArr->rgsabound->cElements;
  if (getDocInfo()->nMimeDigestLen > 0) {
    SafeArrayAccessData(pArr, (void HUGEP**)&pData);
    getDocInfo()->szMimeDigest = new unsigned char[getDocInfo()->nMimeDigestLen];
    memcpy(getDocInfo()->szMimeDigest, pData, getDocInfo()->nMimeDigestLen);
    SafeArrayUnaccessData(pArr);
  }

	return S_OK;
}

STDMETHODIMP CComDocInfo::get_nDigestLen(long *pVal)
{
	*pVal = getDocInfo()->nDigestLen;

	return S_OK;
}

STDMETHODIMP CComDocInfo::get_nMimeDigestLen(long *pVal)
{
	*pVal = getDocInfo()->nMimeDigestLen;

	return S_OK;
}




//////////////////////////////////////////////////////////////
//        methods
//////////////////////////////////////////////////////////////



////////////////////////////////////////////////////////////////////
//    helpers
////////////////////////////////////////////////////////////////////
CComDocInfo::CComDocInfo() {
  m_pointerMode = false;
  m_pDocInfo = new DocInfo;
  memset(m_pDocInfo, 0, sizeof(DocInfo));
}

CComDocInfo::~CComDocInfo() {
  if (!m_pointerMode)
    freeStruct();
}

DocInfo* CComDocInfo::getDocInfo() {
  return m_pDocInfo;
}


void CComDocInfo::shiftStructPointer(DocInfo* pNew) {
  if (!m_pointerMode)
    freeStruct();
  m_pDocInfo = pNew;
  m_pointerMode = true;
}

void CComDocInfo::freeStruct() {
  DocInfo_free(m_pDocInfo);
}
