/*

Wrap of DigiCoc library DocInfo structure to provide COM-interface
Copyright (C) AS Sertifitseerimiskeskus

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

GNU Lesser General Public Licence is available at
http://www.gnu.org/copyleft/lesser.html

*/
// ComDocInfo.h : Declaration of the CComDocInfo

#ifndef __COMDOCINFO_H_
#define __COMDOCINFO_H_

#include "resource.h"       // main symbols

/////////////////////////////////////////////////////////////////////////////
// CComDocInfo

#include "libdigidoc/DigiDocLib.h"

class ATL_NO_VTABLE CComDocInfo : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CComDocInfo, &CLSID_ComDocInfo>,
	public IDispatchImpl<IComDocInfo, &IID_IComDocInfo, &LIBID_DIGIDOCLIBCOMLib>
{
public:
  CComDocInfo();
  ~CComDocInfo();

DECLARE_REGISTRY_RESOURCEID(IDR_COMDOCINFO)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CComDocInfo)
	COM_INTERFACE_ENTRY(IComDocInfo)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()

// IComDocInfo
public:
	STDMETHOD(get_szDocId)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(put_szDocId)(/*[in]*/ BSTR newVal);
	STDMETHOD(get_szDigestType)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(put_szDigestType)(/*[in]*/ BSTR newVal);
	STDMETHOD(get_baDigest)(/*[out, retval]*/ VARIANT *pVal);
	STDMETHOD(put_baDigest)(/*[in]*/ VARIANT newVal);
	STDMETHOD(get_nDigestLen)(/*[out, retval]*/ long *pVal);
	STDMETHOD(get_baMimeDigest)(/*[out, retval]*/ VARIANT *pVal);
	STDMETHOD(put_baMimeDigest)(/*[in]*/ VARIANT newVal);
	STDMETHOD(get_nMimeDigestLen)(/*[out, retval]*/ long *pVal);

  DocInfo* getDocInfo();
  void shiftStructPointer(DocInfo* pNew);
  void freeStruct();

protected:
  DocInfo* m_pDocInfo;
  bool m_pointerMode;
};

#endif //__COMDOCINFO_H_
