// ComEncryptedData.cpp : Implementation of CComEncryptedData

#include "stdafx.h"
#include "ComEncryptedData.h"
#include "ComEncryptionProperty.h"
#include "ComEncryptedKey.h"
#include "Converters.h"

#include "libdigidoc/DigiDocConvert.h"


// CComEncryptedData

	CComEncryptedData::CComEncryptedData()
	{
		m_pEncryptedData = NULL;
	}

	CComEncryptedData::~CComEncryptedData()
	{
		if(m_pEncryptedData != NULL)
		  dencEncryptedData_free(m_pEncryptedData);
	}

	DEncEncryptedData* CComEncryptedData::getEncryptedData()
	{
		return(m_pEncryptedData);
	}
		
	void CComEncryptedData::shiftStructPointer(DEncEncryptedData* pNew)
	{
		if(m_pEncryptedData != NULL)
		  dencEncryptedData_free(m_pEncryptedData);
		m_pEncryptedData = pNew;
	}

	
	STDMETHODIMP CComEncryptedData::GetId(BSTR* lpEncData)
	{
		if(m_pEncryptedData != NULL)
		Convert::out_retval_sz2BSTR((char *)dencEncryptedData_GetId(m_pEncryptedData), lpEncData);
		return S_OK;
	}

	STDMETHODIMP CComEncryptedData::GetType(BSTR* lpEncData)
	{
		if(m_pEncryptedData != NULL)
		Convert::out_retval_sz2BSTR((char *)dencEncryptedData_GetType(m_pEncryptedData), lpEncData);
		return S_OK;
	}

	STDMETHODIMP CComEncryptedData::GetMimeType(BSTR* lpEncData)
	{
		if(m_pEncryptedData != NULL)
		Convert::out_retval_sz2BSTR((char *)dencEncryptedData_GetMimeType(m_pEncryptedData), lpEncData);
		return S_OK;
	}

	STDMETHODIMP CComEncryptedData::GetXmlNs(BSTR* lpEncData)
	{
		if(m_pEncryptedData != NULL)
		Convert::out_retval_sz2BSTR((char *)dencEncryptedData_GetXmlNs(m_pEncryptedData), lpEncData);
		return S_OK;
	}

	STDMETHODIMP CComEncryptedData::GetEncryptionMethod(BSTR* lpEncData)
	{
		if(m_pEncryptedData != NULL)
		Convert::out_retval_sz2BSTR((char *)dencEncryptedData_GetEncryptionMethod(m_pEncryptedData), lpEncData);
		return S_OK;
	}

	STDMETHODIMP CComEncryptedData::GetEncryptionPropertiesId(BSTR* lpEncData)
	{
		if(m_pEncryptedData != NULL)
		Convert::out_retval_sz2BSTR((char *)dencEncryptedData_GetEncryptionPropertiesId(m_pEncryptedData), lpEncData);
		return S_OK;
	}

	STDMETHODIMP CComEncryptedData::GetEncryptionPropertiesCount(LONG* nRetResult)
	{
		if(m_pEncryptedData != NULL)
		*nRetResult = dencEncryptedData_GetEncryptionPropertiesCount(m_pEncryptedData); 
		return S_OK;
	}

	STDMETHODIMP CComEncryptedData::GetEncryptedKeyCount(LONG* nRetResult)
	{
		if(m_pEncryptedData != NULL)
		*nRetResult = dencEncryptedData_GetEncryptedKeyCount(m_pEncryptedData); 
		return S_OK;
	}

	STDMETHODIMP CComEncryptedData::GetEncryptedDataStatus(LONG* nRetResult)
	{
		if(m_pEncryptedData != NULL)
		*nRetResult = dencEncryptedData_GetEncryptedDataStatus(m_pEncryptedData); 
		return S_OK;
	}

	STDMETHODIMP CComEncryptedData::SetId(BSTR szValue, LONG* nRetResult)
	{
		USES_CONVERSION;
		if(m_pEncryptedData != NULL)
		*nRetResult = dencEncryptedData_SetId(m_pEncryptedData,GetBSTR(szValue)); 

		return S_OK;
	}

	STDMETHODIMP CComEncryptedData::SetType(BSTR szValue, LONG* nRetResult)
	{
		USES_CONVERSION;
		if(m_pEncryptedData != NULL)
		*nRetResult = dencEncryptedData_SetType(m_pEncryptedData,GetBSTR(szValue)); 
		return S_OK;
	}

	STDMETHODIMP CComEncryptedData::SetMimeType(BSTR szValue, LONG* nRetResult)
	{
		USES_CONVERSION;
		if(m_pEncryptedData != NULL)
		*nRetResult = dencEncryptedData_SetMimeType(m_pEncryptedData,GetBSTR(szValue)); 
		return S_OK;
	}

	STDMETHODIMP CComEncryptedData::SetXmlNs(BSTR szValue, LONG* nRetResult)
	{
		USES_CONVERSION;
		if(m_pEncryptedData != NULL)
		*nRetResult = dencEncryptedData_SetXmlNs(m_pEncryptedData,GetBSTR(szValue)); 
		return S_OK;
	}

	STDMETHODIMP CComEncryptedData::SetEncryptionMethod(BSTR szValue, LONG* nRetResult)
	{
		USES_CONVERSION;
		if(m_pEncryptedData != NULL)
		*nRetResult = dencEncryptedData_SetEncryptionMethod(m_pEncryptedData,GetBSTR(szValue)); 
		return S_OK;
	}

	STDMETHODIMP CComEncryptedData::AppendData(BSTR szData, LONG nDataLen, LONG* nRetResult)
	{
		USES_CONVERSION;
		if(m_pEncryptedData != NULL)
		*nRetResult = dencEncryptedData_AppendData(m_pEncryptedData,GetBSTR(szData),nDataLen); 
		return S_OK;
	}

	STDMETHODIMP CComEncryptedData::SetEncryptionPropertiesId(BSTR szValue, LONG* nRetResult)
	{
		USES_CONVERSION;
		if(m_pEncryptedData != NULL)
		*nRetResult = dencEncryptedData_SetEncryptionPropertiesId(m_pEncryptedData,GetBSTR(szValue)); 
		return S_OK;
	}

	STDMETHODIMP CComEncryptedData::DeleteEncryptionProperty(LONG nIdx, LONG* nRetResult)
	{
		if(m_pEncryptedData != NULL)
		*nRetResult = dencEncryptedData_DeleteEncryptionProperty(m_pEncryptedData,nIdx); 
		return S_OK;
	}

	STDMETHODIMP CComEncryptedData::DeleteEncryptedKey(LONG nIdx, LONG* nRetResult)
	{
		if(m_pEncryptedData != NULL)
		*nRetResult = dencEncryptedData_DeleteEncryptedKey(m_pEncryptedData,nIdx); 
		return S_OK;
	}

	STDMETHODIMP CComEncryptedData::EncryptData(LONG nCompressionOption, LONG* nRetResult)
	{
		if(m_pEncryptedData != NULL)
		*nRetResult = dencEncryptedData_encryptData(m_pEncryptedData,nCompressionOption); 
		return S_OK;
	}

	STDMETHODIMP CComEncryptedData::DecryptData(LONG* nRetResult)
	{
		if(m_pEncryptedData != NULL)
		*nRetResult = dencEncryptedData_decryptData(m_pEncryptedData); 
		return S_OK;
	}

	STDMETHODIMP CComEncryptedData::CompressData(LONG nCompressOption, LONG* nRetResult)
	{
		if(m_pEncryptedData != NULL)
		*nRetResult = dencEncryptedData_compressData(m_pEncryptedData,nCompressOption); 
		return S_OK;
	}

	STDMETHODIMP CComEncryptedData::DecompressData(LONG* nRetResult)
	{
		if(m_pEncryptedData != NULL)
		*nRetResult = dencEncryptedData_decompressData(m_pEncryptedData); 
		return S_OK;
	}

	STDMETHODIMP CComEncryptedData::GetEncryptionProperty(LONG nIdx, IComEncryptionProperty * pEncProperty)
	{
		if(m_pEncryptedData != NULL) {
		DEncEncryptionProperty *pProperty = dencEncryptedData_GetEncryptionProperty(m_pEncryptedData,nIdx); 
		if (pProperty != NULL)
		  ((CComEncryptionProperty *)pEncProperty)->shiftStructPointer(pProperty);
		}
		return S_OK;
	}

	STDMETHODIMP CComEncryptedData::GetLastEncryptionProperty(IComEncryptionProperty * pEncProperty)
	{
		if(m_pEncryptedData != NULL) {
		DEncEncryptionProperty *pProperty = dencEncryptedData_GetLastEncryptionProperty(m_pEncryptedData); 
		if (pProperty != NULL)
		  ((CComEncryptionProperty *)pEncProperty)->shiftStructPointer(pProperty);
		}
		return S_OK;
	}

	STDMETHODIMP CComEncryptedData::GetEncryptedKey(LONG nIdx, IComEncryptedKey * lpEncryptedKey)
	{
		if(m_pEncryptedData != NULL) {
		DEncEncryptedKey *pKey = dencEncryptedData_GetEncryptedKey(m_pEncryptedData,nIdx); 
		if (pKey != NULL)
		  ((CComEncryptedKey *)lpEncryptedKey)->shiftStructPointer(pKey);
		}
		return S_OK;
	}

	STDMETHODIMP CComEncryptedData::GetLastEncryptedKey(IComEncryptedKey * lpEncryptedKey)
	{
		if(m_pEncryptedData != NULL) {
		DEncEncryptedKey *pKey = dencEncryptedData_GetLastEncryptedKey(m_pEncryptedData); 
		if (pKey != NULL)
		  ((CComEncryptedKey *)lpEncryptedKey)->shiftStructPointer(pKey);
		}
		return S_OK;
	}

	STDMETHODIMP CComEncryptedData::Decrypt(IComEncryptedKey * lpEncKey, BSTR szPin, 
			BSTR clib_conffilepath, BSTR out_file, LONG* nRetResult)
	{
		USES_CONVERSION;
		DEncEncryptedKey *pKey = NULL;
		FILE* hFile;
		pKey = ((CComEncryptedKey *)lpEncKey)->getEncryptedKey();
		DEncEncryptedData *pData = getEncryptedData();
		
		//int err = readConfigFile(GetBSTR(clib_conffilepath), ITEM_TYPE_GLOBAL);
		*nRetResult = dencEncryptedData_decrypt(pData, pKey ,GetBSTR(szPin));
		
		if((hFile = fopen(GetBSTR(out_file), "wb")) != NULL) {
			fwrite((pData)->mbufEncryptedData.pMem, 1, (pData)->mbufEncryptedData.nLen, hFile);
			fclose(hFile); 
		}

		return S_OK;
	}

	STDMETHODIMP CComEncryptedData::Create(BSTR szXmlNs, BSTR szEncMode, BSTR szId, BSTR szType, BSTR szMimeType, LONG* nRetResult)
	{
		USES_CONVERSION;
		DEncEncryptedData *pData = NULL;
		*nRetResult = dencEncryptedData_new(&pData,GetBSTR(szXmlNs),GetBSTR(szEncMode), GetBSTR(szId), GetBSTR(szType),GetBSTR(szMimeType));
		if (pData != NULL)
		  shiftStructPointer(pData);
		return S_OK;
	}

	STDMETHODIMP CComEncryptedData::FindEncryptionPropertyByName(IComEncryptionProperty * lpEncProperty, BSTR szName)
	{
		USES_CONVERSION;
		if(m_pEncryptedData != NULL) {
		DEncEncryptionProperty *pProperty = dencEncryptedData_FindEncryptionPropertyByName(m_pEncryptedData,GetBSTR(szName)); 
		if (pProperty != NULL)
		  ((CComEncryptionProperty *)lpEncProperty)->shiftStructPointer(pProperty);
		}
		return S_OK;
	}
BOOL ExportPlainSessionBlob(HCRYPTKEY hPublicKey,
                            HCRYPTKEY hSessionKey,
                            LPBYTE *pbKeyMaterial ,
                            DWORD *dwKeyMaterial )
{
   BOOL fReturn = FALSE;
   BOOL fResult;
   DWORD dwSize, n;
   LPBYTE pbSessionBlob = NULL;
   DWORD dwSessionBlob;
   LPBYTE pbPtr;

   __try
   {
      *pbKeyMaterial  = NULL;
      *dwKeyMaterial  = 0;

      fResult = CryptExportKey(hSessionKey, hPublicKey, SIMPLEBLOB,
                               0, NULL, &dwSessionBlob );
      if (!fResult) __leave;

      pbSessionBlob  = (LPBYTE)LocalAlloc(LPTR, dwSessionBlob );
      if (!pbSessionBlob) __leave;

      fResult = CryptExportKey(hSessionKey, hPublicKey, SIMPLEBLOB,
                               0, pbSessionBlob , &dwSessionBlob );
      if (!fResult) __leave;

      // Get session key size in bits
      dwSize = sizeof(DWORD);
      fResult = CryptGetKeyParam(hSessionKey, KP_KEYLEN, (LPBYTE)dwKeyMaterial, &dwSize, 0);
      if (!fResult) __leave;

      // Get the number of bytes and allocate buffer
      *dwKeyMaterial /= 8;
      *pbKeyMaterial = (LPBYTE)LocalAlloc(LPTR, *dwKeyMaterial);
      if (!*pbKeyMaterial) __leave;

      // Skip the header
      pbPtr = pbSessionBlob;
      pbPtr += sizeof(BLOBHEADER);
      pbPtr += sizeof(ALG_ID);

      // We are at the beginning of the key
      // but we need to start at the end since 
      // it's reversed
      pbPtr += (*dwKeyMaterial - 1);
      
      // Copy the raw key into our return buffer      
      for (n = 0; n < *dwKeyMaterial; n++)
      {
         (*pbKeyMaterial)[n] = *pbPtr;
         pbPtr--;
      }      
      
      fReturn = TRUE;
   }
   __finally
   {
      if (pbSessionBlob) LocalFree(pbSessionBlob);

      if ((!fReturn) && (*pbKeyMaterial ))
      {
         LocalFree(*pbKeyMaterial );
         *pbKeyMaterial  = NULL;
         *dwKeyMaterial  = 0;
      }
   }

   return fReturn;
}


BOOL ImportPlainSessionBlob(HCRYPTPROV hProv,
                            HCRYPTKEY hPrivateKey,
                            ALG_ID dwAlgId,
                            LPBYTE pbKeyMaterial ,
                            DWORD dwKeyMaterial ,
                            HCRYPTKEY *hSessionKey)
{
   BOOL fResult;   
   BOOL fReturn = FALSE;
   BOOL fFound = FALSE;
   LPBYTE pbSessionBlob = NULL;
   DWORD dwSessionBlob, dwSize, n;
   DWORD dwPublicKeySize;
   DWORD dwProvSessionKeySize;
   ALG_ID dwPrivKeyAlg;
   LPBYTE pbPtr; 
   DWORD dwFlags = CRYPT_FIRST;
   PROV_ENUMALGS_EX ProvEnum;
   HCRYPTKEY hTempKey = 0;

   __try
   {
      // Double check to see if this provider supports this algorithm
      // and key size
      do
      {        
         dwSize = sizeof(ProvEnum);
         fResult = CryptGetProvParam(hProv, PP_ENUMALGS_EX, (LPBYTE)&ProvEnum,
                                     &dwSize, dwFlags);
         if (!fResult) break;

         dwFlags = 0;

         if (ProvEnum.aiAlgid == dwAlgId) fFound = TRUE;
                                     
      } while (!fFound);

      if (!fFound) __leave;

      // We have to get the key size(including padding)
      // from an HCRYPTKEY handle.  PP_ENUMALGS_EX contains
      // the key size without the padding so we can't use it.
      fResult = CryptGenKey(hProv, dwAlgId, 0, &hTempKey);
      if (!fResult) __leave;
      
      dwSize = sizeof(DWORD);
      fResult = CryptGetKeyParam(hTempKey, KP_KEYLEN, (LPBYTE)&dwProvSessionKeySize,
                                 &dwSize, 0);
      if (!fResult) __leave;      
      CryptDestroyKey(hTempKey);
      hTempKey = 0;

      // Our key is too big, leave
      if ((dwKeyMaterial * 8) > dwProvSessionKeySize) __leave;

      // Get private key's algorithm
      dwSize = sizeof(ALG_ID);
      fResult = CryptGetKeyParam(hPrivateKey, KP_ALGID, (LPBYTE)&dwPrivKeyAlg, &dwSize, 0);
      if (!fResult) __leave;

      // Get private key's length in bits
      dwSize = sizeof(DWORD);
      fResult = CryptGetKeyParam(hPrivateKey, KP_KEYLEN, (LPBYTE)&dwPublicKeySize, &dwSize, 0);
      if (!fResult) __leave;

      // calculate Simple blob's length
      dwSessionBlob = (dwPublicKeySize/8) + sizeof(ALG_ID) + sizeof(BLOBHEADER);

      // allocate simple blob buffer
      pbSessionBlob = (LPBYTE)LocalAlloc(LPTR, dwSessionBlob);
      if (!pbSessionBlob) __leave;

      pbPtr = pbSessionBlob;

      // SIMPLEBLOB Format is documented in SDK
      // Copy header to buffer
      ((BLOBHEADER *)pbPtr)->bType = SIMPLEBLOB;
      ((BLOBHEADER *)pbPtr)->bVersion = 2;
      ((BLOBHEADER *)pbPtr)->reserved = 0;
      ((BLOBHEADER *)pbPtr)->aiKeyAlg = dwAlgId;
      pbPtr += sizeof(BLOBHEADER);

      // Copy private key algorithm to buffer
      *((DWORD *)pbPtr) = dwPrivKeyAlg;
      pbPtr += sizeof(ALG_ID);

      // Place the key material in reverse order
      for (n = 0; n < dwKeyMaterial; n++)
      {
         pbPtr[n] = pbKeyMaterial[dwKeyMaterial-n-1];
      }
     
      // 3 is for the first reserved byte after the key material + the 2 reserved bytes at the end.
      dwSize = dwSessionBlob - (sizeof(ALG_ID) + sizeof(BLOBHEADER) + dwKeyMaterial + 3);
      pbPtr += (dwKeyMaterial+1);

      // Generate random data for the rest of the buffer
      // (except that last two bytes)
      fResult = CryptGenRandom(hProv, dwSize, pbPtr);
      if (!fResult) __leave;

      for (n = 0; n < dwSize; n++)
      {
         if (pbPtr[n] == 0) pbPtr[n] = 1;
      }

      pbSessionBlob[dwSessionBlob - 2] = 2;

      fResult = CryptImportKey(hProv, pbSessionBlob , dwSessionBlob, 
                               hPrivateKey, CRYPT_EXPORTABLE, hSessionKey);
      if (!fResult) __leave;

      fReturn = TRUE;           
   }
   __finally
   {
      if (hTempKey) CryptDestroyKey(hTempKey);
      if (pbSessionBlob) LocalFree(pbSessionBlob);
   }
   
   return fReturn;
}

	STDMETHODIMP CComEncryptedData::Decrypt_WithKey(IComEncryptedKey * lpEncKey, BSTR out_file, LONG* nRetResult)
	{
		USES_CONVERSION;
		
		DEncEncryptedKey *pKey = NULL;
		unsigned char *key = NULL;
		DWORD key_len = 0; 
		HCRYPTPROV hProv;
		HCRYPTKEY hPrivKey; 
		FILE* hFile;
		DEncEncryptedData *pData = getEncryptedData();
		BOOL success;
		HCERTSTORE hStore;
		char storeName[] = "My";
		DWORD location = CERT_SYSTEM_STORE_CURRENT_USER;
		PCCERT_CONTEXT pCertContext = NULL;
		PCCERT_CONTEXT pCertFindContext = NULL;
		int i = 0; 
		DWORD keySpec; 
		BOOL mustFree;
		unsigned char* certBlob; 
		int certBlobLen; 
		DWORD nerr = 0; 
		HCRYPTKEY hPubKey;
		HCRYPTKEY hSesKey;
		BYTE *pbKeyBlob; 
		DWORD dwBlobLen;
		HCRYPTHASH hHash = 0;
		int fResult;


		pKey = ((CComEncryptedKey *)lpEncKey)->getEncryptedKey();
		if (!pKey) {  
			*nRetResult = ERR_DENC_KEY_STATUS; 	
			goto cleanup; 
		}

		key = (unsigned char*)pKey->mbufTransportKey.pMem; 
		key_len = pKey->mbufTransportKey.nLen;  

		hStore = CertOpenStore(CERT_STORE_PROV_SYSTEM_A,X509_ASN_ENCODING | PKCS_7_ASN_ENCODING,NULL,
						CERT_STORE_OPEN_EXISTING_FLAG | location, storeName);
		
		if (!hStore) {
			TRACE("CertOpenStore open failed with 0x%0lx ", GetLastError());
			*nRetResult = ERR_DENC_DECRYPT;
			SET_LAST_ERROR(1000 + GetLastError());
			goto cleanup; 			
		}

		certBlobLen = i2d_X509((X509*)pKey->pCert, NULL);
		certBlob = new unsigned char[certBlobLen]; 
		
		encodeCert(pKey->pCert,(char *)certBlob,&certBlobLen);
		if (!certBlob) {
			TRACE("encodeCert failed with 0x%0lx ", GetLastError());
			*nRetResult = ERR_DENC_DECRYPT;
			goto cleanup; 			
		}		

		pCertFindContext = CertCreateCertificateContext(X509_ASN_ENCODING|PKCS_7_ASN_ENCODING,certBlob,certBlobLen);
		if (!pCertFindContext) {
			TRACE("CertCreateCertificateContext open failed with 0x%0lx ", GetLastError());
			*nRetResult = ERR_DENC_DECRYPT;
			SET_LAST_ERROR(GetLastError());
			SET_LAST_ERROR(1000 + GetLastError());
			goto cleanup; 			
		}

		pCertContext = CertFindCertificateInStore(hStore, X509_ASN_ENCODING | PKCS_7_ASN_ENCODING, 
									0, CERT_FIND_EXISTING, 
									pCertFindContext, NULL); 

		if (pCertContext) { //cert found 
			
			TRACE("pCertContext cert found", "");
			success = CryptAcquireCertificatePrivateKey(pCertContext,
									NULL,NULL,&hProv,&keySpec, &mustFree);
			if (success) {
					
//					if(hProv) CryptReleaseContext(hProv,0);

/*					success = CryptAcquireCertificatePrivateKey(pCertContext, //not silent csp handle
													NULL,NULL,&hProv,&keySpec, &mustFree); */
					
					if (success) {

						TRACE("CryptAcquireCertificatePrivateKey success", "");
						if(RCRYPT_FAILED(CryptGetUserKey(hProv, AT_KEYEXCHANGE, &hPrivKey))) {
							TRACE("CryptGetUserKey failed with 0x%0lx ", GetLastError());	
							*nRetResult = ERR_DENC_DECRYPT;
							SET_LAST_ERROR(GetLastError());
							SET_LAST_ERROR(1000 + GetLastError());
							goto cleanup; 
						}

						/*{ //endian-fix
						LPBYTE tmp = new BYTE[key_len] ;
						for(int f=0;f<key_len;f++) tmp[f] = key[(key_len - 1) - f];
						memcpy(key,tmp,key_len);
						delete []tmp;
						}*/
//						_CrtDbgBreak();
/*	CryptImportPublicKeyInfo(
        hProv, 
        X509_ASN_ENCODING, 
        &pCertContext->pCertInfo->SubjectPublicKeyInfo, 
        &hPubKey);

  if(CryptExportKey(   
   hPrivKey,    
   NULL,    
   PRIVATEKEYBLOB,
   0,    
   NULL, 
   &dwBlobLen)) 
{
     printf("Size of the BLOB for the public key determined. \n");
}

//-------------------------------------------------------------------
// Allocate memory for the pbKeyBlob.

if(pbKeyBlob = (BYTE*)malloc(dwBlobLen)) 
{
    printf("Memory has been allocated for the BLOB. \n");
}

	if(CryptExportKey(   
   hPrivKey, 
   NULL,    
   PRIVATEKEYBLOB,    
   0,    
   pbKeyBlob,    
   &dwBlobLen))
{
     printf("Contents have been written to the BLOB. \n");
}

*/
    if(CryptImportKey(hProv, key, key_len,hPrivKey,CRYPT_NO_SALT,&hSesKey))
    {
        printf("The key has been imported.\n");
    }
    else
    {
        printf("Public key import failed.\n");
		nerr = GetLastError(); 
		TRACE("CryptDecrypt failed with 0x%0lx ", nerr);
        //return FALSE; // VS: try without? This doesn't work on softcertificates (pkcs12 key containers), but is also not necessary
    }
	    // Get the public key information for the certificate.


	//CryptImportKey(hProv,pbKeyBlob,dwBlobLen,hPrivKey,0,&hSesKey);

// Import this key and get an HCRYPTKEY handle
   /*   if (!ImportPlainSessionBlob(hProv, hPrivKey, CALG_AES_128, key, key_len, &hSesKey))
      {
		  TRACE("CryptDecrypt failed with 0x%0lx ", GetLastError());
         printf("ImportPlainSessionBlob failed with %x\n", GetLastError());
         //__leave;
      }

      //LocalFree(pbKeyMaterial);
      //pbKeyMaterial = NULL;
	  key = NULL;

      printf("Exporting 3DES key.  We should get back 1,2,3,...\n");
      // Export it and get the key material back
      // It should be 1,2,3, ...
      fResult = ExportPlainSessionBlob(hPrivKey, hSesKey, 
                                       &key, &key_len );
      if (!fResult)
      {
         printf("ExportPlainSessionBlob failed with %x\n", GetLastError());
         TRACE("CryptDecrypt failed with 0x%0lx ", GetLastError());
		 //__leave;
      }
*/

						if(RCRYPT_FAILED(CryptDecrypt(hPrivKey, 0, TRUE, 0, key, &key_len))) {
							nerr = GetLastError(); 

							if (nerr == NTE_BAD_DATA || nerr == NTE_FAIL || nerr == NTE_BAD_KEY) { //special case to rev array

								/* this code can be used to reaquire context for special flags or something */
								{
									BYTE cspname[MAX_PATH];
									DWORD dwLen = sizeof(cspname);
									BYTE contname[MAX_PATH];
									
									SET_LAST_ERROR(1000 + nerr);

									success = CryptGetProvParam(hProv, PP_NAME, cspname, &dwLen,0);
									if (!success) goto cleanup;

									dwLen = sizeof(contname);
									success= CryptGetProvParam(hProv, PP_CONTAINER, contname, &dwLen,0);
									if (!success) goto cleanup;

									if (hPrivKey) CryptDestroyKey(hPrivKey);
									if(hProv) CryptReleaseContext(hProv,0);

									success = CryptAcquireContext(&hProv, (PCHAR )contname, (PCHAR) cspname, PROV_RSA_FULL,0);
									if (!success) goto cleanup;

									success = CryptGetUserKey(hProv, AT_KEYEXCHANGE, &hPrivKey);
									if (!success) goto cleanup;

									clearErrors();
								}
								/**/								

								{ //endian-fix again for EstEID CSP
								LPBYTE tmp = new BYTE[key_len] ;
								for(int f=0;f<key_len;f++) tmp[f] = key[(key_len - 1) - f];
								memcpy(key,tmp,key_len);
								delete []tmp;
								}

								if(RCRYPT_FAILED(CryptDecrypt(hPrivKey, 0, TRUE, 0, key, &key_len))) {
									nerr = GetLastError(); 
									TRACE("CryptDecrypt failed with 0x%0lx ", nerr);

									if (nerr ==  SCARD_W_CANCELLED_BY_USER) {
										*nRetResult = ERR_CSP_USER_CANCEL;
									} else {
										*nRetResult = ERR_DENC_DECRYPT;
									}
									
									SET_LAST_ERROR(1000 + nerr);
									goto cleanup;  
									}
								}
							else {

								TRACE("CryptDecrypt failed with 0x%0lx ", nerr);

								if (nerr ==  SCARD_W_CANCELLED_BY_USER) {
									*nRetResult = ERR_CSP_USER_CANCEL;
								} else {
									*nRetResult = ERR_DENC_DECRYPT;
								}
								
								SET_LAST_ERROR(1000 + nerr);
								goto cleanup;  
								}

							}
						clearErrors();
						*nRetResult = ERR_OK; 
					}

			} else { //CryptAcquire failed
				TRACE("CryptAquireCertificatePrivateKey failed with 0x%0lx ", GetLastError());
				*nRetResult = ERR_PRIV_CERT_NOT_FOUND; 
				SET_LAST_ERROR(1000 + GetLastError());
				goto cleanup;
			}

			*nRetResult = dencEncryptedData_decrypt_withKey(pData, (const char *)key, key_len); 
			if (*nRetResult != ERR_OK) goto cleanup; 

			if((hFile = fopen(GetBSTR(out_file), "wb")) != NULL) {
				fwrite((pData)->mbufEncryptedData.pMem, 1, (pData)->mbufEncryptedData.nLen, hFile);
				fclose(hFile); 
			}
		
		} else {
			TRACE("ERR_PRIV_CERT_NOT_FOUND", "");
			*nRetResult = ERR_PRIV_CERT_NOT_FOUND; 
			SET_LAST_ERROR(1000 + GetLastError());
			goto cleanup;
		}

cleanup:
		
		if(hProv) CryptReleaseContext(hProv,0);
		if(hPrivKey) CryptDestroyKey(hPrivKey);
		if(certBlob) delete certBlob; 
		if(pCertContext) CertFreeCertificateContext(pCertContext);
		if(pCertFindContext) CertFreeCertificateContext(pCertFindContext);
		

		CertCloseStore(hStore, CERT_CLOSE_STORE_CHECK_FLAG);

		return S_OK;
	}


	STDMETHODIMP CComEncryptedData::SaveCDOC(/*UTF8 */BSTR save_path, long *pVal){
		string sz_savepath = _bstr_t(save_path);
		FILE* hFile;
		*pVal = ERR_OK; 

		if (m_pEncryptedData && sz_savepath.length() > 0) {
			if(m_pEncryptedData->nDataStatus == DENC_DATA_STATUS_ENCRYPTED_AND_NOT_COMPRESSED ||
				m_pEncryptedData->nDataStatus == DENC_DATA_STATUS_ENCRYPTED_AND_COMPRESSED) {
			
				*pVal = dencGenEncryptedData_writeToFile(m_pEncryptedData, sz_savepath.c_str());

			} else {

				//FIX: fopen wants non-utf8
				DWORD bufSz = lstrlenW(save_path) * 4;
				char *convFileName = new char[bufSz];
				ddocConvertFileName( convFileName, bufSz, GetBSTR(save_path) );
				sz_savepath = convFileName;


				if((hFile = fopen(sz_savepath.c_str(), "wb")) != NULL) {
					fwrite((m_pEncryptedData)->mbufEncryptedData.pMem, 1, (m_pEncryptedData)->mbufEncryptedData.nLen, hFile);
					fclose(hFile);	
				} else {
					*pVal = ERR_FILE_WRITE;
				}
				
			}
		} else {
			*pVal = ERR_FILE_WRITE;
		}

		return S_OK;
	}

	STDMETHODIMP CComEncryptedData::OpenCDOC(/*UTF8 */ BSTR file_path, long *pVal){
		*pVal = ERR_OK;
		string sz_file_path = _bstr_t(file_path); 
		
		//if (PathFileExists(sz_file_path.c_str())) {
			*pVal = dencSaxReadEncryptedData(&m_pEncryptedData, sz_file_path.c_str());
		//} else {
		//	*pVal = ERR_FILE_READ; 
		//}

		return S_OK;
	}

	STDMETHODIMP CComEncryptedData::AppendFile(/*UTF8 */BSTR file_path, long *pVal){
		DWORD bufSz = lstrlenW(file_path) * 4;
		char *convFileName = new char[bufSz];
		ddocConvertFileName( convFileName, bufSz, GetBSTR(file_path) );
		
		string sz_filepath = convFileName;//_bstr_t(file_path); 
		FILE *hSource; 
		long lSize;
		char *buffer;
		*pVal = ERR_FILE_READ;

		if (!PathFileExists(sz_filepath.c_str())) goto cleanup;
		
		if(!(hSource = fopen(sz_filepath.c_str(),"rb"))) goto cleanup; 
		if(fseek(hSource, 0, SEEK_END)) goto cleanup;

		lSize = ftell(hSource);
		if (lSize == -1L) goto cleanup;  
		rewind(hSource);
		
		buffer = new char[lSize]; 
		fread(buffer, 1, lSize, hSource);
		if(ferror(hSource)) goto cleanup;
		
		*pVal = dencEncryptedData_AppendData(m_pEncryptedData, buffer, lSize);

cleanup: 
		delete [] convFileName;
		if(hSource) fclose(hSource); 
		if (buffer) delete buffer;
		
		return S_OK;
	}


