// ComEncryptedData.h : Declaration of the CComEncryptedData

#pragma once
#include "resource.h"       // main symbols

#include "DigiDocLibCOM_h.h"
#include "libdigidoc/DigiDocEnc.h"
#include "libdigidoc/DigiDocEncSAXParser.h"


// CComEncryptedData

class ATL_NO_VTABLE CComEncryptedData : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CComEncryptedData, &CLSID_ComEncryptedData>,
	public IDispatchImpl<IComEncryptedData, &IID_IComEncryptedData, &LIBID_DIGIDOCLIBCOMLib, /*wMajor =*/ 1, /*wMinor =*/ 0>
{
public:
	CComEncryptedData();
	~CComEncryptedData();

DECLARE_REGISTRY_RESOURCEID(IDR_COMENCRYPTEDDATA)


BEGIN_COM_MAP(CComEncryptedData)
	COM_INTERFACE_ENTRY(IComEncryptedData)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()


	DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct()
	{
		return S_OK;
	}
	
	void FinalRelease() 
	{
	}

public:

	STDMETHOD(GetId)(BSTR* lpEncData);
	STDMETHOD(GetType)(BSTR* lpEncData);
	STDMETHOD(GetMimeType)(BSTR* lpEncData);
	STDMETHOD(GetXmlNs)(BSTR* lpEncData);
	STDMETHOD(GetEncryptionMethod)(BSTR* lpEncData);
	STDMETHOD(GetEncryptionPropertiesId)(BSTR* lpEncData);
	STDMETHOD(GetEncryptionPropertiesCount)(LONG* nRetResult);
	STDMETHOD(GetEncryptedKeyCount)(LONG* nRetResult);
	STDMETHOD(GetEncryptedDataStatus)(LONG* nRetResult);
	STDMETHOD(SetId)(BSTR szValue, LONG* nRetResult);
	STDMETHOD(SetType)(BSTR szValue, LONG* nRetResult);
	STDMETHOD(SetMimeType)(BSTR szValue, LONG* nRetResult);
	STDMETHOD(SetXmlNs)(BSTR szValue, LONG* nRetResult);
	STDMETHOD(SetEncryptionMethod)(BSTR szValue, LONG* nRetResult);
	STDMETHOD(AppendData)(BSTR szData, LONG nDataLen, LONG* nRetResult);
	STDMETHOD(SetEncryptionPropertiesId)(BSTR szValue, LONG* nRetResult);
	STDMETHOD(DeleteEncryptionProperty)(LONG nIdx, LONG* nRetResult);
	STDMETHOD(DeleteEncryptedKey)(LONG nIdx, LONG* nRetResult);
	STDMETHOD(EncryptData)(LONG nCompressionOption, LONG* nRetResult);
	STDMETHOD(DecryptData)(LONG* nRetResult);
	STDMETHOD(CompressData)(LONG nCompressOption, LONG* nRetResult);
	STDMETHOD(DecompressData)(LONG* nRetResult);
	STDMETHOD(GetEncryptionProperty)(LONG nIdx, IComEncryptionProperty * lpEncProperty);
	STDMETHOD(GetLastEncryptionProperty)(IComEncryptionProperty * lpEncproperty);
	STDMETHOD(GetEncryptedKey)(LONG nIdx, IComEncryptedKey * lpEncryptedKey);
	STDMETHOD(GetLastEncryptedKey)(IComEncryptedKey * lpEncryptedKey);
	STDMETHOD(Decrypt)(IComEncryptedKey * lpEncKey, BSTR szPin, BSTR clib_conffilepath, BSTR out_file, LONG* nRetResult);
	DEncEncryptedData* getEncryptedData();
	void shiftStructPointer(DEncEncryptedData* pNew);
private:
	DEncEncryptedData* m_pEncryptedData;
	
public:
	STDMETHOD(AppendFile)(BSTR file_path, long *pVal);
	STDMETHOD(OpenCDOC)(BSTR file_path, long *pVal);
	STDMETHOD(SaveCDOC)(BSTR save_path, long *pVal);
	STDMETHOD(Create)(BSTR szXmlNs, BSTR szEncMode, BSTR szId, BSTR szType, BSTR szMimeType, LONG* nRetResult);
	STDMETHOD(FindEncryptionPropertyByName)(IComEncryptionProperty * lpEncProperty, BSTR szName);
	STDMETHOD(Decrypt_WithKey)(IComEncryptedKey * lpEncKey, BSTR out_file, LONG* nRetResult);
};

//OBJECT_ENTRY_AUTO(__uuidof(ComEncryptedData), CComEncryptedData)
