// ComEncryptedKey.cpp : Implementation of CComEncryptedKey

#include "stdafx.h"
#include "ComEncryptedKey.h"
#include "ComEncryptedData.h"
#include "Converters.h"
#include "libdigidoc/DigiDocConvert.h"

// CComEncryptedKey

	CComEncryptedKey::CComEncryptedKey(){
		m_pEncryptedKey = NULL;
	}

	CComEncryptedKey::~CComEncryptedKey(){
	}

	DEncEncryptedKey* CComEncryptedKey::getEncryptedKey(){
		return(m_pEncryptedKey);
	}

	void CComEncryptedKey::shiftStructPointer(DEncEncryptedKey* pNew){
		m_pEncryptedKey = pNew;
	}

	STDMETHODIMP CComEncryptedKey::GetId(BSTR* lpEncKey){
		if(m_pEncryptedKey)
		Convert::out_retval_sz2BSTR((char *)dencEncryptedKey_GetId(m_pEncryptedKey), lpEncKey);
		return S_OK;
	}

	STDMETHODIMP CComEncryptedKey::GetRecipient(BSTR* lpEncKey){
		if(m_pEncryptedKey)
		Convert::out_retval_sz2BSTR((char *)dencEncryptedKey_GetRecipient(m_pEncryptedKey), lpEncKey);
		return S_OK;
	}

	STDMETHODIMP CComEncryptedKey::GetEncryptionMethod(BSTR* lpEncKey){
		if(m_pEncryptedKey)
		Convert::out_retval_sz2BSTR((char *)dencEncryptedKey_GetEncryptionMethod(m_pEncryptedKey), lpEncKey);
		return S_OK;
	}

	STDMETHODIMP CComEncryptedKey::GetKeyName(BSTR* lpEncKey){
		if(m_pEncryptedKey)
		Convert::out_retval_sz2BSTR((char *)dencEncryptedKey_GetKeyName(m_pEncryptedKey), lpEncKey);
		return S_OK;
	}

	STDMETHODIMP CComEncryptedKey::GetCarriedKeyName(BSTR* lpEncKey){
		if(m_pEncryptedKey)
		Convert::out_retval_sz2BSTR((char *)dencEncryptedKey_GetCarriedKeyName(m_pEncryptedKey), lpEncKey);
		return S_OK;
	}

	STDMETHODIMP CComEncryptedKey::GetIssuer(BSTR* issuer)
	{
		DigiDocMemBuf mbuf1;
		if(m_pEncryptedKey) {
		X509* pCert = dencEncryptedKey_GetCertificate(m_pEncryptedKey);
		char buf[X509_NAME_BUF_LEN];
		int bLen = sizeof(buf);

		mbuf1.pMem = 0;
		mbuf1.nLen = 0;
		if(pCert) {
			ddocCertGetIssuerDN((X509*)pCert, &mbuf1);
			utf82oem((const char*)mbuf1.pMem, buf, bLen);
			Convert::out_retval_sz2BSTR((char *)buf, issuer);
		}
		ddocMemBuf_free(&mbuf1);
		}
		return S_OK;
	}
	
	STDMETHODIMP CComEncryptedKey::GetNotAfter(BSTR *notafter)
	{
		if(m_pEncryptedKey) {
		X509* cert = dencEncryptedKey_GetCertificate(m_pEncryptedKey);
		char buf[X509_NAME_BUF_LEN];
		int bLen = sizeof(buf);
		
//		ASN1_TIME *tm = 0;
		time_t t2;
		struct tm *pT;

		//KERT. changed because asn1time2time_t is not exported anymore
/*		tm = X509_get_notAfter((X509*)cert);
		asn1time2time_t(tm, &t2);
*/
		t2 = getCertNotAfterTimeT(cert);
		pT = localtime(&t2);

		sprintf(buf, "%02d.%02d.%04d %02d:%02d:%02d%",
			pT->tm_mday, pT->tm_mon + 1, 
			pT->tm_year + 1900, pT->tm_hour, pT->tm_min, pT->tm_sec);
		
		Convert::out_retval_sz2BSTR((char *)buf, notafter);
		}
		return S_OK;
	}


	STDMETHODIMP CComEncryptedKey::SetId(BSTR szValue, LONG* nRetResult)
	{
		USES_CONVERSION;
		if(m_pEncryptedKey)
		*nRetResult = dencEncryptedKey_SetId(m_pEncryptedKey,GetBSTR(szValue)); 
		return S_OK;
	}

	STDMETHODIMP CComEncryptedKey::SetRecipient(BSTR szValue, LONG* nRetResult)
	{
		USES_CONVERSION;
		if(m_pEncryptedKey)
		*nRetResult = dencEncryptedKey_SetRecipient(m_pEncryptedKey,GetBSTR(szValue)); 
		return S_OK;
	}

	STDMETHODIMP CComEncryptedKey::SetEncryptionMethod(BSTR szValue, LONG* nRetResult)
	{
		USES_CONVERSION;
		if(m_pEncryptedKey)
		*nRetResult = dencEncryptedKey_SetEncryptionMethod(m_pEncryptedKey,GetBSTR(szValue)); 
		return S_OK;
	}

	STDMETHODIMP CComEncryptedKey::SetKeyName(BSTR szValue, LONG* nRetResult)
	{
		USES_CONVERSION;
		if(m_pEncryptedKey)
		*nRetResult = dencEncryptedKey_SetKeyName(m_pEncryptedKey,GetBSTR(szValue)); 
		return S_OK;
	}

	STDMETHODIMP CComEncryptedKey::SetCarriedKeyName(BSTR szValue, LONG* nRetResult)
	{
		USES_CONVERSION;
		if(m_pEncryptedKey)
		*nRetResult = dencEncryptedKey_SetCarriedKeyName(m_pEncryptedKey,GetBSTR(szValue)); 
		return S_OK;
	}

	STDMETHODIMP CComEncryptedKey::GetCertificate(LONG* hx509Handle)
	{
		if(m_pEncryptedKey)
		*hx509Handle = (long)dencEncryptedKey_GetCertificate(m_pEncryptedKey);
		return S_OK;
	}

	STDMETHODIMP CComEncryptedKey::SetCertificate(LONG hx509Handle, LONG* nRetResult)
	{
		USES_CONVERSION;
		if(m_pEncryptedKey)
		*nRetResult = dencEncryptedKey_SetCertificate(m_pEncryptedKey,(X509 *)hx509Handle); 

		return S_OK;
	}

	STDMETHODIMP CComEncryptedKey::Create(IComEncryptedData * pEncData, BSTR hX509_path, BSTR szEncMethod, 
		BSTR szId, BSTR szRecipient, BSTR szKeyName, BSTR szCarriedKeyname, LONG* nRetResult)
	{
		USES_CONVERSION;
		DEncEncryptedKey *pKey = NULL;
		DEncEncryptedData *pData = NULL;
		pData = ((CComEncryptedData *)pEncData)->getEncryptedData();
		X509* pCert = 0;
		LONG ret = 0;

		string cert_path = _bstr_t(hX509_path);
		if (!PathFileExists(cert_path.c_str())) {
			*nRetResult = ERR_CERT_READ; 
		} else {

			*nRetResult = ReadCertFile(pCert, cert_path.c_str());
			if (!*nRetResult)
				*nRetResult = dencEncryptedKey_new(pData, &pKey, pCert, GetBSTR(szEncMethod), GetBSTR(szId), GetBSTR(szRecipient),GetBSTR(szKeyName),GetBSTR(szCarriedKeyname));
		}

		if (pKey != NULL) shiftStructPointer(pKey);
		return S_OK;
	}


	int CComEncryptedKey::ReadCertFile(X509* &pCert, string cert_path)
	{
		int ret = ERR_CERT_READ; 	
		FILE *hSource; 
		long lSize;
		unsigned char *buffer; 

		if(!(hSource = fopen(cert_path.c_str(),"rb"))) goto cleanup; 
		if(fseek(hSource, 0, SEEK_END)) goto cleanup;

		lSize = ftell(hSource);
		if (lSize == -1L) goto cleanup;  
		rewind(hSource);
		
		buffer = new unsigned char[lSize]; 
		fread(buffer, 1, lSize, hSource);
		if(ferror(hSource)) goto cleanup;
		
		ret = ddocDecodeX509Data(&pCert, buffer, lSize); 
		
cleanup:
		if(hSource) fclose(hSource); 
		if (buffer) delete buffer; 

		return ret; 
	}



