// ComEncryptedKey.h : Declaration of the CComEncryptedKey

#pragma once
#include "resource.h"       // main symbols

#include "DigiDocLibCOM_h.h"
#include "libdigidoc/DigiDocEnc.h"
#include "libdigidoc/DigiDocEncGen.h"

// CComEncryptedKey

class ATL_NO_VTABLE CComEncryptedKey : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CComEncryptedKey, &CLSID_ComEncryptedKey>,
	public IDispatchImpl<IComEncryptedKey, &IID_IComEncryptedKey, &LIBID_DIGIDOCLIBCOMLib, /*wMajor =*/ 1, /*wMinor =*/ 0>
{
public:
	CComEncryptedKey();
	~CComEncryptedKey();

DECLARE_REGISTRY_RESOURCEID(IDR_COMENCRYPTEDKEY)


BEGIN_COM_MAP(CComEncryptedKey)
	COM_INTERFACE_ENTRY(IComEncryptedKey)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()


	DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct()
	{
		return S_OK;
	}
	
	void FinalRelease() 
	{
	}

public:

	STDMETHOD(GetId)(BSTR* lpEncKey);
	STDMETHOD(GetRecipient)(BSTR* lpEncKey);
	STDMETHOD(GetEncryptionMethod)(BSTR* lpEncKey);
	STDMETHOD(GetKeyName)(BSTR* lpEncKey);
	STDMETHOD(GetCarriedKeyName)(BSTR* lpEncKey);
	STDMETHOD(SetId)(BSTR lpValue, LONG* nRetResult);
	STDMETHOD(SetRecipient)(BSTR szValue, LONG* nRetResult);
	STDMETHOD(SetEncryptionMethod)(BSTR szValue, LONG* nRetResult);
	STDMETHOD(SetKeyName)(BSTR szValue, LONG* nRetResult);
	STDMETHOD(SetCarriedKeyName)(BSTR szValue, LONG* nRetResult);
	STDMETHOD(GetCertificate)(LONG* hx509Handle);
	STDMETHOD(SetCertificate)(LONG hx509Handle, LONG* hRetResult);
	void shiftStructPointer(DEncEncryptedKey* pNew);
	DEncEncryptedKey* getEncryptedKey();
	
private:
	DEncEncryptedKey* m_pEncryptedKey;
public:
	STDMETHOD(GetNotAfter)(BSTR* notafter);
	STDMETHOD(GetIssuer)(BSTR* issuer);
	int ReadCertFile(X509* &pCert, string cert_path);
	STDMETHOD(Create)(IComEncryptedData * pEncData, BSTR hX509_path, BSTR szEncMethod, BSTR szId, BSTR szRecipient, BSTR szKeyName, BSTR szCarriedKeyname, LONG* nRetResult);
};

//OBJECT_ENTRY_AUTO(__uuidof(ComEncryptedKey), CComEncryptedKey)
