// ComErrorInfo.cpp : Implementation of CComErrorInfo
#include "stdafx.h"
#include "DigiDocLibCOM_h.h"
#include "ComErrorInfo.h"

/////////////////////////////////////////////////////////////////////////////
// CComErrorInfo


//////////////////////////////////////////////////////////////
//        properties
//////////////////////////////////////////////////////////////

STDMETHODIMP CComErrorInfo::get_nCode(long *pVal)
{
	if (hasContent_Internal())
    *pVal = m_pErrInfo->code;
  else
    *pVal = ERR_OK;

	return S_OK;
}

STDMETHODIMP CComErrorInfo::get_szFileName(BSTR *pVal)
{
  USES_CONVERSION;
	if (hasContent_Internal() && (m_pErrInfo->fileName != (char*)0))
    SetBSTR(pVal, m_pErrInfo->fileName); //*pVal = SysAllocString(A2OLE(m_pErrInfo->fileName));
  else
    SetBSTR(pVal, ""); //*pVal = SysAllocString(A2OLE(""));

	return S_OK;
}

STDMETHODIMP CComErrorInfo::get_nFileLine(long *pVal)
{
	if (hasContent_Internal())
    *pVal = m_pErrInfo->line;
  else
    *pVal = 0;

	return S_OK;
}

STDMETHODIMP CComErrorInfo::get_szAssertion(BSTR *pVal)
{
  USES_CONVERSION;
	if (hasContent_Internal() && (m_pErrInfo->assertion != (char*)0))
    SetBSTR(pVal, m_pErrInfo->assertion); //*pVal = SysAllocString(A2OLE(m_pErrInfo->assertion));
  else
    SetBSTR(pVal,""); //*pVal = SysAllocString(A2OLE(""));

	return S_OK;
}


//////////////////////////////////////////////////////////////
//        methods
//////////////////////////////////////////////////////////////

STDMETHODIMP CComErrorInfo::hasContent(VARIANT *pRetBool)
{
  VariantInit(pRetBool);
  V_VT(pRetBool) = VT_BOOL;
  V_BOOL(pRetBool) = (hasContent_Internal() ? TRUE : FALSE);

	return S_OK;
}

STDMETHODIMP CComErrorInfo::getErrorString(BSTR *pszRetText)
{
  USES_CONVERSION;
	if (hasContent_Internal()) {
	  SetBSTR(pszRetText, ::getErrorString(m_pErrInfo->code)); //*pszRetText = SysAllocString(A2OLE(::getErrorString(m_pErrInfo->code, nLanguage)));
  } else {
    SetBSTR(pszRetText, ""); //*pszRetText = SysAllocString(A2OLE(""));
  }

	return S_OK;
}

STDMETHODIMP CComErrorInfo::getNextUnreadError(VARIANT *pbRetResult)
{
  VariantInit(pbRetResult);
	V_VT(pbRetResult) = VT_BOOL;

  m_pErrInfo = getErrorInfo();
  V_BOOL(pbRetResult) = (m_pErrInfo ? TRUE : FALSE);
	
  return S_OK;
}

STDMETHODIMP CComErrorInfo::clearErrorInfo()
{
	m_pErrInfo = (ErrorInfo*)0;

	return S_OK;
}

STDMETHODIMP CComErrorInfo::clearAllUnreadErrors()
{
	m_pErrInfo = (ErrorInfo*)0;
  ::clearErrors();

	return S_OK;
}

STDMETHODIMP CComErrorInfo::getErrorStringByCode(long nCode, BSTR *pszRetString)
{
  USES_CONVERSION;
  SetBSTR(pszRetString, ::getErrorString(nCode)); //*pszRetString = SysAllocString(A2OLE(::getErrorString(nCode, nLanguage)));

	return S_OK;
}

////////////////////////////////////////////////////////////////////
//    helpers
////////////////////////////////////////////////////////////////////
bool CComErrorInfo::hasContent_Internal() {
  return ((m_pErrInfo == (ErrorInfo*)0) ? false : true);
}


STDMETHODIMP CComErrorInfo::getErrorClass(LONG nCode, LONG* nClass)
{
*nClass = ::getErrorClass(nCode);
return S_OK;
}
