/*

Wrap of DigiCoc library ErrorInfo structure to provide COM-interface
Copyright (C) AS Sertifitseerimiskeskus

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

GNU Lesser General Public Licence is available at
http://www.gnu.org/copyleft/lesser.html

*/
// ComErrorInfo.h : Declaration of the CComErrorInfo

#ifndef __COMERRORINFO_H_
#define __COMERRORINFO_H_

#include "resource.h"       // main symbols
#include "ComDigiDocLib.h"

/////////////////////////////////////////////////////////////////////////////
// CComErrorInfo

class ATL_NO_VTABLE CComErrorInfo : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CComErrorInfo, &CLSID_ComErrorInfo>,
	public IDispatchImpl<IComErrorInfo, &IID_IComErrorInfo, &LIBID_DIGIDOCLIBCOMLib>
{
public:
	CComErrorInfo()
	{
    m_pErrInfo = (ErrorInfo*)0;
	}

DECLARE_REGISTRY_RESOURCEID(IDR_COMERRORINFO)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CComErrorInfo)
	COM_INTERFACE_ENTRY(IComErrorInfo)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()

// IComErrorInfo
public:
	STDMETHOD(getErrorStringByCode)(/*[in]*/ long nCode, /*[out, retval]*/ BSTR* pszRetString);
	STDMETHOD(clearAllUnreadErrors)();
	STDMETHOD(clearErrorInfo)();
	STDMETHOD(getNextUnreadError)(/*[out, retval]*/ VARIANT* pbRetResult);
	STDMETHOD(getErrorString)(/*[out, retval]*/ BSTR* pszRetText);
	STDMETHOD(hasContent)(/*[out, retval]*/ VARIANT* pRetBool);
	STDMETHOD(get_szAssertion)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(get_nFileLine)(/*[out, retval]*/ long *pVal);
	STDMETHOD(get_szFileName)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(get_nCode)(/*[out, retval]*/ long *pVal);

  bool hasContent_Internal();
protected:
  ErrorInfo* m_pErrInfo;
public:
	STDMETHOD(getErrorClass)(LONG nCode, LONG* nClass);
};

#endif //__COMERRORINFO_H_
