// ComNotaryInfo.cpp : Implementation of CComNotaryInfo
#include "stdafx.h"
#include "DigiDocLibCOM_h.h"
#include "ComNotaryInfo.h"
#include "ComSignedDoc.h"
#include "Converters.h"

/////////////////////////////////////////////////////////////////////////////
// CComNotaryInfo



STDMETHODIMP CComNotaryInfo::get_szId(BSTR *pVal)
{
	if(m_pNotaryInfo)
		Convert::out_retval_sz2BSTR(m_pNotaryInfo->szId, pVal);
	else
		Convert::out_retval_sz2BSTR("", pVal);
	return S_OK;
}

STDMETHODIMP CComNotaryInfo::put_szId(BSTR newVal)
{
	if(m_pNotaryInfo)
		Convert::in_BSTR2sz(newVal, &(m_pNotaryInfo->szId));

	return S_OK;
}

STDMETHODIMP CComNotaryInfo::get_szSigId(BSTR *pVal)
{
	// TODO - no way ?
	if(m_pSigInfo)
		Convert::out_retval_sz2BSTR(m_pSigInfo->szId, pVal);
	else
		Convert::out_retval_sz2BSTR("", pVal);
	return S_OK;
}

STDMETHODIMP CComNotaryInfo::put_szSigId(BSTR newVal)
{
	// TODO - no way ?
	//Convert::in_BSTR2sz(newVal, &(getNotaryInfo()->szSigId));

	return S_OK;
}

STDMETHODIMP CComNotaryInfo::get_szNotType(BSTR *pVal)
{
	if(m_pNotaryInfo)
		Convert::out_retval_sz2BSTR(m_pNotaryInfo->szNotType, pVal);
	else
		Convert::out_retval_sz2BSTR("", pVal);
	return S_OK;
}

STDMETHODIMP CComNotaryInfo::put_szNotType(BSTR newVal)
{
	if(m_pNotaryInfo)
		Convert::in_BSTR2sz(newVal, &(m_pNotaryInfo->szNotType));

	return S_OK;
}

STDMETHODIMP CComNotaryInfo::get_timeProduced(BSTR *pVal)
{
	if(m_pNotaryInfo)
		Convert::out_retval_sz2BSTR(m_pNotaryInfo->timeProduced, pVal);
	else
		Convert::out_retval_sz2BSTR("", pVal);
	return S_OK;
}

STDMETHODIMP CComNotaryInfo::put_timeProduced(BSTR newVal)
{
	if(m_pNotaryInfo)
		Convert::in_BSTR2sz(newVal, &(m_pNotaryInfo->timeProduced));

	return S_OK;
}

STDMETHODIMP CComNotaryInfo::get_szRespIdType(BSTR *pVal)
{
	// can't set this
	if(m_pNotaryInfo)
		Convert::out_retval_sz2BSTR((char*)ddocNotInfo_GetResponderId_Type(m_pNotaryInfo), pVal);
	else
		Convert::out_retval_sz2BSTR("", pVal);
	return S_OK;
}

STDMETHODIMP CComNotaryInfo::put_szRespIdType(BSTR newVal)
{
	// can't set this    
	//Convert::in_BSTR2sz(newVal, &(getNotaryInfo()->szRespIdType));

	return S_OK;
}

STDMETHODIMP CComNotaryInfo::get_baRespId(VARIANT *pVal)
{
	const DigiDocMemBuf* pMBuf = 0;
	
	if(m_pNotaryInfo) {
		pMBuf = ddocNotInfo_GetResponderId(m_pNotaryInfo);
		if(pMBuf)
			Convert::out_retval_ac2VARIANT((char*)pMBuf->pMem, pMBuf->nLen, pVal);
	}
	return S_OK;
}

STDMETHODIMP CComNotaryInfo::get_nRespIdLen(long *pVal)
{
	const DigiDocMemBuf* pMBuf = 0;
	
	*pVal = 0;
	if(m_pNotaryInfo) {
		pMBuf = ddocNotInfo_GetResponderId(getNotaryInfo());
		if(pMBuf)
			*pVal = pMBuf->nLen;
	}
	return S_OK;
}

STDMETHODIMP CComNotaryInfo::get_thisUpdate(BSTR *pVal)
{
	DigiDocMemBuf mbuf1;

	mbuf1.pMem = 0;
	mbuf1.nLen = 0;
	if(m_pNotaryInfo) {
		ddocNotInfo_GetThisUpdate(m_pNotaryInfo, &mbuf1);
		if(mbuf1.pMem) {
			Convert::out_retval_sz2BSTR((char*)mbuf1.pMem, pVal);
			ddocMemBuf_free(&mbuf1);
		}
	}
	return S_OK;
}

STDMETHODIMP CComNotaryInfo::put_thisUpdate(BSTR newVal)
{
	// can't set this    
	//Convert::in_BSTR2sz(newVal, &(getNotaryInfo()->thisUpdate));

	return S_OK;
}

STDMETHODIMP CComNotaryInfo::get_nextUpdate(BSTR *pVal)
{
	DigiDocMemBuf mbuf1;

	mbuf1.pMem = 0;
	mbuf1.nLen = 0;
	if(m_pNotaryInfo) {
		ddocNotInfo_GetNextUpdate(getNotaryInfo(), &mbuf1);
		if(mbuf1.pMem) {
			Convert::out_retval_sz2BSTR((char*)mbuf1.pMem, pVal);
			ddocMemBuf_free(&mbuf1);
		}
	}
	return S_OK;
}

STDMETHODIMP CComNotaryInfo::put_nextUpdate(BSTR newVal)
{
	// can't set this    
	//Convert::in_BSTR2sz(newVal, &(getNotaryInfo()->nextUpdate));

	return S_OK;
}


STDMETHODIMP CComNotaryInfo::get_nCertNr(long *pVal)
{
	CertID* pCertID = 0;
	
	*pVal = 0;
	if(m_pSigInfo) {
		pCertID = ddocSigInfo_GetOrCreateCertIDOfType(m_pSigInfo, CERTID_TYPE_RESPONDERS_CERTID);
		if(pCertID) {
			try {
			_bstr_t tmp = ddocCertID_GetIssuerSerial(pCertID);
			_variant_t vart = tmp;
			*pVal = vart;
			} catch ( exception ){};			
		}
	}
	return S_OK;
}

STDMETHODIMP CComNotaryInfo::put_nCertNr(long newVal)
{
	_bstr_t tmp = newVal;
	//getNotaryInfo()->certNr = newVal;
	// cant't do this!
	//Convert::in_BSTR2sz(tmp,&(getNotaryInfo()->szIssuerSerial));

	return S_OK;
} 

STDMETHODIMP CComNotaryInfo::get_szDigestType(BSTR *pVal)
{
	if(m_pNotaryInfo)
		Convert::out_retval_sz2BSTR(m_pNotaryInfo->szDigestType, pVal);
	else
		Convert::out_retval_sz2BSTR("", pVal);
	return S_OK;
}

STDMETHODIMP CComNotaryInfo::put_szDigestType(BSTR newVal)
{
	if(m_pNotaryInfo)
		Convert::in_BSTR2sz(newVal, &(m_pNotaryInfo->szDigestType));

	return S_OK;
}

STDMETHODIMP CComNotaryInfo::get_szSigType(BSTR *pVal)
{
	if(m_pNotaryInfo)
		Convert::out_retval_sz2BSTR(m_pNotaryInfo->szSigType, pVal);
	else
		Convert::out_retval_sz2BSTR("", pVal);
	return S_OK;
}

STDMETHODIMP CComNotaryInfo::put_szSigType(BSTR newVal)
{
	if(m_pNotaryInfo)
		Convert::in_BSTR2sz(newVal, &(m_pNotaryInfo->szSigType));
	return S_OK;
}

STDMETHODIMP CComNotaryInfo::get_baSigValue(VARIANT *pVal)
{
	const DigiDocMemBuf* pMBuf = 0;

	if(m_pNotaryInfo) {
		pMBuf = ddocNotInfo_GetOcspDigest(m_pNotaryInfo);
		if(pMBuf)
			Convert::out_retval_ac2VARIANT((const char*)pMBuf->pMem, pMBuf->nLen, pVal);
	}
	return S_OK;
}

STDMETHODIMP CComNotaryInfo::get_nSigLen(long *pVal)
{
	const DigiDocMemBuf* pMBuf = 0;
	
	*pVal = 0;
	if(m_pNotaryInfo) {
		pMBuf = ddocNotInfo_GetOcspDigest(m_pNotaryInfo);
		if(pMBuf)
			*pVal = pMBuf->nLen;
	}
	return S_OK;
}

STDMETHODIMP CComNotaryInfo::get_nIssuerSerial(BSTR *pVal)
{
	CertID* pCertID = 0;
	
	if(m_pSigInfo) {
		pCertID = ddocSigInfo_GetOrCreateCertIDOfType(m_pSigInfo, CERTID_TYPE_RESPONDERS_CERTID);
		if(pCertID)
			Convert::out_retval_sz2BSTR((char*)ddocCertID_GetIssuerSerial(pCertID), pVal);
	}
	return S_OK;
}


STDMETHODIMP CComNotaryInfo::get_baCertDigest(VARIANT *pVal)
{
	CertID* pCertID = 0;
	DigiDocMemBuf* pMBuf = 0;

	if(m_pSigInfo) {
		pCertID = ddocSigInfo_GetOrCreateCertIDOfType(m_pSigInfo, CERTID_TYPE_RESPONDERS_CERTID);
		if(pCertID) {
			pMBuf = ddocCertID_GetDigestValue(pCertID);
			if(pMBuf && pMBuf->pMem)
				Convert::out_retval_ac2VARIANT((const char*)pMBuf->pMem, pMBuf->nLen, pVal);
		}
	}
	return S_OK;
}

STDMETHODIMP CComNotaryInfo::get_nCertDigestLen(long *pVal)
{
	CertID* pCertID = 0;
	DigiDocMemBuf* pMBuf = 0;

	*pVal = 0;
	if(m_pSigInfo) {
		pCertID = ddocSigInfo_GetOrCreateCertIDOfType(m_pSigInfo, CERTID_TYPE_RESPONDERS_CERTID);
		if(pCertID) {
			pMBuf = ddocCertID_GetDigestValue(pCertID);
			if(pMBuf && pMBuf->pMem)
				*pVal = pMBuf->nLen;
		}
	}
	return S_OK;
}


STDMETHODIMP CComNotaryInfo::get_baOcspDigest(VARIANT *pVal)
{
	const DigiDocMemBuf* pMBuf = 0;
	
	if(m_pNotaryInfo) {
		pMBuf = ddocNotInfo_GetOcspDigest(m_pNotaryInfo);
		if(pMBuf)
			Convert::out_retval_ac2VARIANT((const char*)pMBuf->pMem, pMBuf->nLen, pVal);
	}
	return S_OK;
}

STDMETHODIMP CComNotaryInfo::get_nOcspDigestLen(long *pVal)
{
	const DigiDocMemBuf* pMBuf = 0;
	
	*pVal = 0;
	if(m_pNotaryInfo) {
		pMBuf = ddocNotInfo_GetOcspDigest(m_pNotaryInfo);
		if(pMBuf)
			*pVal = pMBuf->nLen;
	}
	return S_OK;
}


//////////////////////////////////////////////////////////////
//        methods
//////////////////////////////////////////////////////////////

STDMETHODIMP CComNotaryInfo::verifyNotCert(long *nRetResult)
{
	if(m_pNotaryInfo && m_pSigInfo)
		*nRetResult = ::verifyNotCert(getSignatureInfo(), m_pNotaryInfo);
	return S_OK;
}

STDMETHODIMP CComNotaryInfo::getNotCertData(long *hRetCertHandle)
{
	X509* pCert = 0;
	
	if(m_pSigInfo) {
		pCert = ddocSigInfo_GetOCSPRespondersCert(m_pSigInfo);
		if(pCert)
			*hRetCertHandle = (long)pCert;
	}
	return S_OK;
}

STDMETHODIMP CComNotaryInfo::verifyNotaryDigest(IComSignedDoc* pUseFormatOf, long *nRetCode)
{
	if(m_pNotaryInfo)
		*nRetCode = ::verifyNotaryDigest(((CComSignedDoc*)pUseFormatOf)->getSignedDoc(), m_pNotaryInfo);
	return S_OK;
}



////////////////////////////////////////////////////////////////////
//    helpers
////////////////////////////////////////////////////////////////////
CComNotaryInfo::CComNotaryInfo() {
  m_pNotaryInfo = NULL;
  m_pSigInfo = NULL;
}

CComNotaryInfo::~CComNotaryInfo() {
  // m_pNotaryInfo is freed by lib
}


NotaryInfo* CComNotaryInfo::getNotaryInfo() {
  return m_pNotaryInfo;
}


void CComNotaryInfo::shiftStructPointer(NotaryInfo* pNew) {
  m_pNotaryInfo = pNew;
}


SignatureInfo* CComNotaryInfo::getSignatureInfo()
{
	return m_pSigInfo;
}

void CComNotaryInfo::setSignatureInfo(SignatureInfo* pSigInfo)
{
	m_pSigInfo = pSigInfo;
}
