/*

Wrap of DigiCoc library NotaryInfo structure to provide COM-interface
Copyright (C) AS Sertifitseerimiskeskus

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

GNU Lesser General Public Licence is available at
http://www.gnu.org/copyleft/lesser.html

*/
// ComNotaryInfo.h : Declaration of the CComNotaryInfo

#ifndef __COMNOTARYINFO_H_
#define __COMNOTARYINFO_H_

#include "resource.h"       // main symbols

#include "libdigidoc/DigiDocLib.h"
#include "libdigidoc/DigiDocObj.h"

/////////////////////////////////////////////////////////////////////////////
// CComNotaryInfo
class ATL_NO_VTABLE CComNotaryInfo : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CComNotaryInfo, &CLSID_ComNotaryInfo>,
	public IDispatchImpl<IComNotaryInfo, &IID_IComNotaryInfo, &LIBID_DIGIDOCLIBCOMLib>
{
public:
	CComNotaryInfo();
	~CComNotaryInfo();

DECLARE_REGISTRY_RESOURCEID(IDR_COMNOTARYINFO)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CComNotaryInfo)
	COM_INTERFACE_ENTRY(IComNotaryInfo)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()

// IComNotaryInfo
public:
	STDMETHOD(verifyNotaryDigest)(/*[in]*/ IComSignedDoc* pUseFormatOf, /*[out, retval]*/ long* nRetCode);
	STDMETHOD(get_nOcspDigestLen)(/*[out, retval]*/ long *pVal);
	STDMETHOD(get_baOcspDigest)(/*[out, retval]*/ VARIANT *pVal);
	STDMETHOD(getNotCertData)(/*[out, retval]*/ long* hRetCertHandle);
	STDMETHOD(verifyNotCert)(/*[out, retval]*/ long* nRetResult);
	STDMETHOD(get_nCertDigestLen)(/*[out, retval]*/ long *pVal);
	STDMETHOD(get_baCertDigest)(/*[out, retval]*/ VARIANT *pVal);
	STDMETHOD(get_nIssuerSerial)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(get_nSigLen)(/*[out, retval]*/ long *pVal);
	STDMETHOD(get_baSigValue)(/*[out, retval]*/ VARIANT *pVal);
	STDMETHOD(get_szSigType)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(put_szSigType)(/*[in]*/ BSTR newVal);
	STDMETHOD(get_szDigestType)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(put_szDigestType)(/*[in]*/ BSTR newVal);
	STDMETHOD(get_nCertNr)(/*[out, retval]*/ long *pVal);
	STDMETHOD(put_nCertNr)(/*[in]*/ long newVal);
	STDMETHOD(get_nextUpdate)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(put_nextUpdate)(/*[in]*/ BSTR newVal);
	STDMETHOD(get_thisUpdate)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(put_thisUpdate)(/*[in]*/ BSTR newVal);
	STDMETHOD(get_nRespIdLen)(/*[out, retval]*/ long *pVal);
	STDMETHOD(get_baRespId)(/*[out, retval]*/ VARIANT *pVal);
	STDMETHOD(get_szRespIdType)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(put_szRespIdType)(/*[in]*/ BSTR newVal);
	STDMETHOD(get_timeProduced)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(put_timeProduced)(/*[in]*/ BSTR newVal);
	STDMETHOD(get_szNotType)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(put_szNotType)(/*[in]*/ BSTR newVal);
	STDMETHOD(get_szSigId)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(put_szSigId)(/*[in]*/ BSTR newVal);
	STDMETHOD(get_szId)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(put_szId)(/*[in]*/ BSTR newVal);

  NotaryInfo* getNotaryInfo();
  SignatureInfo* getSignatureInfo();

  void shiftStructPointer(NotaryInfo* pNew);
  void setSignatureInfo(SignatureInfo* pSigInfo);
  
protected:
  NotaryInfo* m_pNotaryInfo;
  SignatureInfo* m_pSigInfo;
};

#endif //__COMNOTARYINFO_H_
