// ComPolicyIdentifierArray.cpp : Implementation of CComPolicyIdentifierArray

#include "stdafx.h"
#include "DigiDocLibCOM_h.h"
#include "ComPolicyIdentifierArray.h"
#include "Converters.h"
#include "libdigidoc/DigiDocMem.h"
#include "libdigidoc/DigiDocCert.h"
#include "libdigidoc/DigiDocConvert.h"



// CComPolicyIdentifierArray


STDMETHODIMP CComPolicyIdentifierArray::get_m_nPolicyIdentifierCount(LONG *pVal)
{
	*pVal = iPolicyIdentifierCount;
	return S_OK;
}

STDMETHODIMP CComPolicyIdentifierArray::get_szUserNotice(LONG iIndex, BSTR *lpResult)
{
	DigiDocMemBuf mbuf1, mbuf2;
	char * p1 = GetItemValue(iIndex,dPolicIdent_UserNotice);
	if(!p1)
		p1 = "";
	mbuf1.pMem = p1;
	mbuf1.nLen = strlen((char*)mbuf1.pMem);
	mbuf2.pMem = 0;
	mbuf2.nLen = 0;
	USES_CONVERSION;
	ddocMemSetLength(&mbuf2, mbuf1.nLen + 10);
    utf82oem((const char*)mbuf1.pMem, (char*)mbuf2.pMem, mbuf2.nLen);
	SetBSTR(lpResult, (char*)mbuf2.pMem); 
	ddocMemBuf_free(&mbuf2);
	return S_OK;
}

STDMETHODIMP CComPolicyIdentifierArray::read_CertPolicies(long lX509, LONG *lpCounter)
{
	int iResult;
	X509 *pX509;
	pX509 = (X509 *)lX509;
	ReleaseAllMem();
	iResult = readCertPolicies(pX509,&pPolicyIdentifierList, &iPolicyIdentifierCount); 
	*lpCounter = iPolicyIdentifierCount;
	return S_OK;
}

STDMETHODIMP CComPolicyIdentifierArray::get_szCPS(LONG iIndex, BSTR *lpResult)
{
	char *psVal = GetItemValue(iIndex,dPolicIdent_CPS);
	if(!psVal) psVal = "";
	USES_CONVERSION;
	SetBSTR(lpResult, psVal); //*lpResult = SysAllocString(A2OLE(psVal));
	return S_OK;
}

STDMETHODIMP CComPolicyIdentifierArray::get_szOID(LONG iIndex, BSTR *lpResult)
{
	char *psVal = GetItemValue(iIndex,dPolicIdent_OID);
	if(!psVal) psVal = "";
	USES_CONVERSION;
	SetBSTR(lpResult, psVal); //*lpResult = SysAllocString(A2OLE(psVal));
	return S_OK;
}

void CComPolicyIdentifierArray::ReleaseAllMem(void)
{
	if(pPolicyIdentifierList != NULL)
		PolicyIdentifiers_free(pPolicyIdentifierList,iPolicyIdentifierCount);
	pPolicyIdentifierList = NULL;
	iPolicyIdentifierCount = 0;
}

char * CComPolicyIdentifierArray::GetItemValue(int iIndex, int iType)
{
	char *psRes = NULL;
	PolicyIdentifier *pPolicyItem;
	if (iIndex >= 0 && iIndex < iPolicyIdentifierCount)
	{
		pPolicyItem = pPolicyIdentifierList+iIndex;
		if(iType == dPolicIdent_UserNotice)
			psRes = pPolicyItem->szUserNotice;
		if(iType == dPolicIdent_CPS)
			psRes = pPolicyItem->szCPS;
		if(iType == dPolicIdent_OID)
			psRes = pPolicyItem->szOID;
	}
	return(psRes);
}

STDMETHODIMP CComPolicyIdentifierArray::isCompanyPolicy(LONG iIndex, LONG * lpResult)
{
	int iRes = 0;
	PolicyIdentifier *pPolicyItem;
	if (iIndex >= 0 && iIndex < iPolicyIdentifierCount)
	{
		pPolicyItem = pPolicyIdentifierList+iIndex;
		iRes = isCompanyCPSPolicy(pPolicyItem);
	}
	*lpResult = iRes;
	return S_OK;
}
