// ComPolicyIdentifierArray.h : Declaration of the CComPolicyIdentifierArray

#pragma once
#include "resource.h"       // main symbols

#include "libdigidoc/DigiDocLib.h"

#define dPolicIdent_UserNotice  0
#define dPolicIdent_CPS         1
#define dPolicIdent_OID         2

// CComPolicyIdentifierArray

class ATL_NO_VTABLE CComPolicyIdentifierArray : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CComPolicyIdentifierArray, &CLSID_ComPolicyIdentifierArray>,
	public IDispatchImpl<IComPolicyIdentifierArray, &IID_IComPolicyIdentifierArray, &LIBID_DIGIDOCLIBCOMLib, /*wMajor =*/ 1, /*wMinor =*/ 0>
{
public:
	CComPolicyIdentifierArray()
		: iPolicyIdentifierCount(0)
		, pPolicyIdentifierList(NULL)
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_COMPOLICYIDENTIFIERARRAY)


BEGIN_COM_MAP(CComPolicyIdentifierArray)
	COM_INTERFACE_ENTRY(IComPolicyIdentifierArray)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()


	DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct()
	{
		return S_OK;
	}
	
	void FinalRelease() 
	{
    ReleaseAllMem();
	}

public:
	STDMETHOD(get_m_nPolicyIdentifierCount)(LONG *pVal);
	STDMETHOD(get_szUserNotice)(LONG iIndex, BSTR *lpResult);
	STDMETHOD(read_CertPolicies)(long lX509, LONG *lpCounter);
	STDMETHOD(get_szCPS)(LONG iIndex, BSTR *lpResult);
	STDMETHOD(get_szOID)(LONG iIndex, BSTR *lpResult);

private:
	int iPolicyIdentifierCount;
	PolicyIdentifier *pPolicyIdentifierList;
private:
	void ReleaseAllMem(void);
	char * GetItemValue(int iIndex, int iType);
public:
	STDMETHOD(isCompanyPolicy)(LONG iIndex, LONG * lpResult);
};

//OBJECT_ENTRY_AUTO(__uuidof(ComPolicyIdentifierArray), CComPolicyIdentifierArray)
