/*

Wrap of DigiCoc library Timestamp structure to provide COM-interface
Copyright (C) AS Sertifitseerimiskeskus

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

GNU Lesser General Public Licence is available at
http://www.gnu.org/copyleft/lesser.html

*/
// ComTimestamp.h : Declaration of the CComTimestamp

#ifndef __COMTIMESTAMP_H_
#define __COMTIMESTAMP_H_

#include "resource.h"       // main symbols
#include "libdigidoc/DigiDocDefs.h"
#include "libdigidoc/DigiDocLib.h"
#include "libdigidoc/DigiDocObj.h"
#include "libdigidoc/DigiDocGen.h"

/////////////////////////////////////////////////////////////////////////////
// CComTimestamp
class ATL_NO_VTABLE CComTimestamp : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CComTimestamp, &CLSID_ComTimestamp>,
	public IDispatchImpl<IComTimestamp, &IID_IComTimestamp, &LIBID_DIGIDOCLIBCOMLib>
{
public:
	CComTimestamp()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_COMTIMESTAMP)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CComTimestamp)
	COM_INTERFACE_ENTRY(IComTimestamp)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()

// IComTimestamp
public:
	STDMETHOD(getString)(/*[in]*/ IComSignedDoc* pUseFormatOf, /*[out, retval]*/ BSTR* szRetString);
	STDMETHOD(readFromString)(/*[in]*/ IComSignedDoc* pUseFormatOf, /*[in]*/ BSTR szReadFrom);
	STDMETHOD(get_tz)(/*[out, retval]*/ long *pVal);
	STDMETHOD(put_tz)(/*[in]*/ long newVal);
	STDMETHOD(get_second)(/*[out, retval]*/ long *pVal);
	STDMETHOD(put_second)(/*[in]*/ long newVal);
	STDMETHOD(get_minute)(/*[out, retval]*/ long *pVal);
	STDMETHOD(put_minute)(/*[in]*/ long newVal);
	STDMETHOD(get_hour)(/*[out, retval]*/ long *pVal);
	STDMETHOD(put_hour)(/*[in]*/ long newVal);
	STDMETHOD(get_day)(/*[out, retval]*/ long *pVal);
	STDMETHOD(put_day)(/*[in]*/ long newVal);
	STDMETHOD(get_month)(/*[out, retval]*/ long *pVal);
	STDMETHOD(put_month)(/*[in]*/ long newVal);
	STDMETHOD(get_year)(/*[out, retval]*/ long *pVal);
	STDMETHOD(put_year)(/*[in]*/ long newVal);

  Timestamp* getTimestamp() { return &m_timestamp; }

protected:
  Timestamp m_timestamp;
};

#endif //__COMTIMESTAMP_H_
