
#include "Converters.h"
#include "ComDef.h"


void SetBSTR(BSTR *lpBstr, char *psValue)
{
	USES_CONVERSION;
	if (psValue && (int)psValue != 0xdddddddd && strlen(psValue))
		*lpBstr = SysAllocString(A2OLE(psValue));
	else
		*lpBstr = SysAllocString(A2OLE(""));
}

/*
static char *psTempGet[32];
static int  iGetNo = 0;

char *GetBSTR(BSTR lpBstr)
{
char *psRes = NULL;
USES_CONVERSION;
if (iGetNo < 30)
  ++iGetNo;
else
  iGetNo = 0;
if (::SysStringLen(lpBstr) > 0)
  psTempGet[iGetNo] = OLE2A(lpBstr);
else
  psTempGet[iGetNo] = NULL;
return(psTempGet[iGetNo]);
}
*/

static char sTempGet[32][1024];
static int  iGetNo = 0;
char *GetBSTR(BSTR lpBstr)
{
char *psTemp = &sTempGet[iGetNo][0];
char *psRes = NULL;
_bstr_t bsTemp(lpBstr);

if (bsTemp.length() > 0)
  {
  USES_CONVERSION;
  strcpy(psTemp,OLE2A(lpBstr));
  psRes = (char *)psTemp;
  
  }
if (iGetNo < 30)
  ++iGetNo;
else
  iGetNo = 0;
return(psRes);
}



void Convert::copyBSTR2sz_noAlloc(BSTR copyFrom, char* copyTo) {
  USES_CONVERSION;
  strcpy(copyTo, GetBSTR(copyFrom));
}

void Convert::copysz2BSTR_withAlloc(char* copyFrom, BSTR* copyTo) {
  USES_CONVERSION;
	
	SetBSTR(copyTo, copyFrom ? copyFrom : ""); //*copyTo = ::SysAllocString(A2OLE(copyFrom));
}


void Convert::out_retval_sz2BSTR(char* copyFrom, BSTR* copyTo) {
  USES_CONVERSION;
  if (copyFrom == (char*)0) {
    SetBSTR(copyTo, ""); //*copyTo = ::SysAllocString(A2OLE(""));
  } else {
    SetBSTR(copyTo, copyFrom); //*copyTo = ::SysAllocString(A2OLE(copyFrom));
  }
}


void Convert::in_BSTR2sz(BSTR copyFrom, char** copyTo) {
  unsigned int newLen = SysStringLen(copyFrom);

  if (*copyTo != (char*)0)
    delete *copyTo;
  
  if (newLen > 0) {
    USES_CONVERSION;
    *copyTo = new char[newLen + 1];
    strcpy(*copyTo, GetBSTR(copyFrom));
  }
}



void Convert::out_retval_ac2VARIANT(const char* pCopyFrom, int copyLength, VARIANT* pStoreTo) {
	if (pCopyFrom == (const char*)0) {
    V_VT(pStoreTo)= VT_EMPTY;
  } else {
    SAFEARRAY* pArr = SafeArrayCreateVector(VT_UI1, 0, copyLength);

    V_ARRAY(pStoreTo) = pArr;
    V_VT(pStoreTo) = (VT_ARRAY | VT_UI1);

    byte HUGEP* pData;
    SafeArrayAccessData(pArr, (void HUGEP**)&pData);

    memcpy(pData, pCopyFrom, copyLength);
    SafeArrayUnaccessData(pArr);
  }

}

void Convert::in_VARIANT2ac(VARIANT pCopyFrom, char** copyTo, int* setLength) {
	if (*copyTo != (char*)0)
    delete *copyTo;
  
  SAFEARRAY* pArr = V_ARRAY(&pCopyFrom);
  byte HUGEP* pData;

  *setLength = pArr->rgsabound->cElements;
  if (*setLength > 0) {
    SafeArrayAccessData(pArr, (void HUGEP**)&pData);
    *copyTo = new char[*setLength];
    memcpy(*copyTo, pData, *setLength);
    SafeArrayUnaccessData(pArr);
  }
}

void Convert::in_VARIANT2szarr(VARIANT pCopyFrom, char**& copyTo, int* setLength) {
	if (copyTo != (char**)0) {
    delete [] copyTo;
  }

  SAFEARRAY* pArr = V_ARRAY(&pCopyFrom);
  BSTR HUGEP* pData;

  *setLength = pArr->rgsabound->cElements;
  if (*setLength > 0) {
    SafeArrayAccessData(pArr, (void HUGEP**)&pData);
    copyTo = new char*[*setLength];
    for(int i = 0; i < *setLength; i++) {
      copyTo[i] = new char[SysStringLen(pData[i]) + 1];
      copyBSTR2sz_noAlloc(pData[i], copyTo[i]);
    }
    SafeArrayUnaccessData(pArr);
  }
}


void Convert::out_szarr2VARIANT(char** copyFrom, VARIANT* pCopyTo, int nLength) {

    SAFEARRAY* pArr = SafeArrayCreateVector(VT_BSTR, 0, nLength);

    V_ARRAY(pCopyTo) = pArr;
    V_VT(pCopyTo) = (VT_ARRAY | VT_BSTR);

    BSTR HUGEP* pData;
    SafeArrayAccessData(pArr, (void HUGEP**)&pData);

    USES_CONVERSION;
    for(int i = 0; i < nLength; i++) {
      copysz2BSTR_withAlloc(copyFrom[i], &(pData[i]));
    }

    SafeArrayUnaccessData(pArr);
}
