/*

Provides some useful converters between C and COM data types.
Copyright (C) AS Sertifitseerimiskeskus

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

GNU Lesser General Public Licence is available at
http://www.gnu.org/copyleft/lesser.html

*/

#ifndef __CONVERTERS_H__
#define __CONVERTERS_H__

#include "stdafx.h"

void SetBSTR(BSTR *lpBstr, char *psValue);
char *GetBSTR(BSTR lpBstr);


class Convert {
public:
  static void copyBSTR2sz_noAlloc(BSTR copyFrom, char* copyTo);
  static void copysz2BSTR_withAlloc(char* copyFrom, BSTR* copyTo);

  static void out_retval_sz2BSTR(char* copyFrom, BSTR* copyTo);
  
  static void in_BSTR2sz(BSTR copyFrom, char** copyTo);

  static void out_retval_ac2VARIANT(const char* pCopyFrom, int copyLength, VARIANT* pStoreTo);
  // if copyTo is not NULL then performs delete.
  static void in_VARIANT2ac(VARIANT pCopyFrom, char** copyTo, int* setLength);

  // if copyTo is not NULL then performs delete.
  static void in_VARIANT2szarr(VARIANT pCopyFrom, char**& copyTo, int* setLength);

  static void out_szarr2VARIANT(char** copyFrom, VARIANT* pCopyTo, int nLength);

	__inline static void ToHex(DigiDocMemBuf* p)
	{
		int x = p->nLen;

		ddocMemSetLength(p, x * 2);

		char* w = "0123456789ABCDEF";
		char* n = (char*)p->pMem;

		while (x-- > 0)
		{
			char u = n[x];
	
		

			n[ (x * 2) + 1 ] = (char) w[u & 0xF];
			n[ (x * 2) + 0 ] = (char) w[(u >> 4) & 0xF];

			
		}
	}
};


// Defines for much used code:
// as OLE2A, but in case string is NULL or has zero length, gives 'NULL'
//#define OLE2A_NULL4EMPTY_STR(str) ((str && (::SysStringLen(str) > 0)) ? OLE2A(str) : NULL)



#endif // __CONVERTERS_H__
