// DigiDocLibCOM.cpp : Implementation of DLL Exports.


// Note: Proxy/Stub Information
//      To build a separate proxy/stub DLL, 
//      run nmake -f DigiDocLibCOMps.mk in the project directory.

#include "stdafx.h"
#include "resource.h"
#include <initguid.h>
#include "DigiDocLibCOM_h.h"
//#include "DigiDocLibCOM_i.c"
#include <libdigidoc/DigiDocLib.h>
#include "ComDigiDocLib.h"
#include "ComDocInfo.h"
#include "ComSignatureInfo.h"
#include "ComDataFile.h"
#include "ComNotaryInfo.h"
#include "ComSignedDoc.h"
#include "ComErrorInfo.h"
#include "ComTimestamp.h"
#include "ComCertSearchStore.h"
#include "ComCertSearch.h"
#include "ComCertificate.h"
#include "ComCertArray.h"
#include "ComEncryptedData.h"
#include "ComEncryptedKey.h"
#include "ComEncryptionProperty.h"
#include "ComPolicyIdentifierArray.h"

CComModule _Module;

BEGIN_OBJECT_MAP(ObjectMap)
OBJECT_ENTRY(CLSID_ComDigiDocLib, CComDigiDocLib)
OBJECT_ENTRY(CLSID_ComDocInfo, CComDocInfo)
OBJECT_ENTRY(CLSID_ComSignatureInfo, CComSignatureInfo)
OBJECT_ENTRY(CLSID_ComDataFile, CComDataFile)
OBJECT_ENTRY(CLSID_ComNotaryInfo, CComNotaryInfo)
OBJECT_ENTRY(CLSID_ComSignedDoc, CComSignedDoc)
OBJECT_ENTRY(CLSID_ComErrorInfo, CComErrorInfo)
OBJECT_ENTRY(CLSID_ComTimestamp, CComTimestamp)
OBJECT_ENTRY(CLSID_ComCertSearchStore, CComCertSearchStore)
OBJECT_ENTRY(CLSID_ComCertSearch, CComCertSearch)
OBJECT_ENTRY(CLSID_ComCertificate, CComCertificate)
OBJECT_ENTRY(CLSID_ComCertArray, CComCertArray)
OBJECT_ENTRY(CLSID_ComEncryptedData, CComEncryptedData)
OBJECT_ENTRY(CLSID_ComEncryptionProperty, CComEncryptionProperty)
OBJECT_ENTRY(CLSID_ComEncryptedKey, CComEncryptedKey)
OBJECT_ENTRY(CLSID_ComPolicyIdentifierArray, CComPolicyIdentifierArray)
END_OBJECT_MAP()

/////////////////////////////////////////////////////////////////////////////
// DLL Entry Point

extern "C"
BOOL WINAPI DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID /*lpReserved*/)
{
    if (dwReason == DLL_PROCESS_ATTACH)
    {
        _Module.Init(ObjectMap, hInstance, &LIBID_DIGIDOCLIBCOMLib);
        DisableThreadLibraryCalls(hInstance);
		::initDigiDocLib();
		// init also from config file
		::initConfigStore(NULL);
    }
    else if (dwReason == DLL_PROCESS_DETACH) {
        ::finalizeDigiDocLib();
		_Module.Term();
	}
    return TRUE;    // ok
}

/////////////////////////////////////////////////////////////////////////////
// Used to determine whether the DLL can be unloaded by OLE

//#ifdef VS_BUILD
STDAPI DllCanUnloadNow(void)
{
    return (_Module.GetLockCount()==0) ? S_OK : S_FALSE;
}

/////////////////////////////////////////////////////////////////////////////
// Returns a class factory to create an object of the requested type

STDAPI DllGetClassObject(REFCLSID rclsid, REFIID riid, LPVOID* ppv)
{
    return _Module.GetClassObject(rclsid, riid, ppv);
}
//#endif

/////////////////////////////////////////////////////////////////////////////
// DllRegisterServer - Adds entries to the system registry

STDAPI DllRegisterServer(void)
{
    // registers object, typelib and all interfaces in typelib
    return _Module.RegisterServer(TRUE);
}

/////////////////////////////////////////////////////////////////////////////
// DllUnregisterServer - Removes entries from the system registry

STDAPI DllUnregisterServer(void)
{
    return _Module.UnregisterServer(TRUE);
}


